<?php

namespace HCM\Geral\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\Util\MsgCalculo;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Error;
use HCM\Geral\Repository\ValidacaoSistemaRepository;
use HCM\Geral\Repository\ESocialRepository;
use Teknisa\Model\Gestaopessoas\Entities\FpaMsgcalculo;
use HCM\FPA\Calculos\Geral\Estruturacao;
use HCM\FPA\Entity\FpatipoassoceveEntity;
use HCM\FPA\Entity\FpatipoincideEntity;
use HCM\FPA\Entity\FpatabelafolhaEntity;
use HCM\FPA\Entity\FpafaixatabelaEntity;
use HCM\FPA\Entity\FpaincideventoEntity;
use HCM\FPA\Entity\GpemovimentacaoEntity;
use HCM\Util\FPA;
use Teknisa\Model\Geral\Entities\Relacionaparc;


class ValidacaoSistemaService {
    
    protected $entityManager;
    protected $hcmParameters;
    protected $vinculo;
    protected $estruturaLegal;
    protected $estruturaGeren;
    protected $estruturaSind;
    protected $estruturaTom;
    protected $escala;
    protected $endereco;
    protected $contCorrParc;
    protected $objComunicacoesParc;
    protected $ocupacao;
    protected $pessoa;
    protected $enderecoPessoa;
    protected $contCorrParcPessoa;
    protected $alteSituFunc;
    protected $alteOcupacao;
    protected $alteSalario;
    protected $situFunc;
    protected $ferias;
    protected $situacaoFuncional;
    protected $vinculoEmpreg;
    protected $dependentes;
    protected $tipoMsg;
    protected $iteCalcFolha;
    protected $valorEventos = array();
    protected $referenciaEventos = array();
    protected $valorFerias = array();
    protected $referenciaFerias = array();
    protected $nrcalculoFolha;
    protected $calculoFerias;
    protected $incideFGTS;
    protected $incideINSS;
    protected $incideIRRF;
    protected $incideFerias;
    protected $eventoFeriasFolha;
    protected $segundaParte;
    protected $segundaParteFolha;
    protected $grupoIncide;
    protected $vlrMaxINSS;
    protected $nrorg;
    protected $nrorg_padrao;
    protected $rubricaeSocial;
    
    
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, ValidacaoSistemaRepository $ValidacaoSistemaRepository, ESocialRepository $eSocialRepository) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->validacaoSistemaRepository = $ValidacaoSistemaRepository;
        $this->eSocialRepository = $eSocialRepository;
    }
       
    public function geraValidacao($dataSet){
        
        $mesCompetencia = $this->hcmParameters->getDtCompetencia();
        $nrorg = $this->hcmParameters->getNrorgTrabalho();
        $this->nrorg = $nrorg;
        $nrorgPadrao = $this->hcmParameters->getNrorgPadrao();
        $this->nrorg_padrao = $nrorgPadrao;
        $ultimoDiaMes = DateUtil::truncateString(DateUtil::getUltimoDiaDoMes(substr($mesCompetencia, 0, 10)));
        $this->tipoMsg = $dataSet["IDTIPOMSG"];
        $nrtipomovimento = 1;
        $nmtipomovimento = $this->entityManager->getRepository(Repositories::FPA_TIPOMOVIMENT)->findOneBy(array('nrtipomoviment' => $nrtipomovimento))->getNmtipomoviment();
        $nrtipomovimentoferias = 2;
        $nmtipomovimentoferias = $this->entityManager->getRepository(Repositories::FPA_TIPOMOVIMENT)->findOneBy(array('nrtipomoviment' => $nrtipomovimentoferias))->getNmtipomoviment();
        $nrTpModalidadeCalc = 1;
        $nrOcorrenciaCalc = 1;
        
        //Vinculos
        $vinculos = $this->validacaoSistemaRepository->retornaVinculos($dataSet);
        
        //Situacao Funcional
        $tmp = $this->entityManager->getRepository(Repositories::GPE_SITUFUNCM)->retornaSituacaoFuncional($nrorgPadrao, $nrorg, $mesCompetencia);
        $situacaoFuncional = array();
        foreach ($tmp as $tmp_situacao) {
            $situacaoFuncional[$tmp_situacao->getNrsitufuncm()] = $tmp_situacao;
        }
        
        // Cálculo folha
        $nrcalculoFolha = FPA::determinaNrCalculoFolha($nrtipomovimento);
        $this->nrcalculoFolha = $nrcalculoFolha; 
        
        foreach($vinculos as $vinculo){
            $this->vinculo = $vinculo;
            
           
            $nrVinculom = $vinculo->getNrvinculom();
            $nrEstrutLegal = $vinculo->historico->getNrestrutlegal();
            $nrEstrutGeren = $vinculo->historico->getNrestrutgeren();
            $nrEstrutSind = $vinculo->historico->getNrestrutsind();
            $nrPessoa = $vinculo->getNrpessoa();
            
            if($dataSet['DSORIGMSG'] === 'VALIDASISTEMA' || !$dataSet['DSORIGMSG']){
                
                $this->entityManager->getRepository(Repositories::FPA_MSGCALCULO)->limpaMsgCalculoVinculo(
                    $this->nrcalculoFolha, 
                    $nrVinculom, 
                    $nrorg, 
                    'VALIDASISTEMA'
                );

                /*$this->entityManager->getRepository(Repositories::FPA_MSGCALCULO)->limpaMsgCalculoProcesso(
                    $this->nrcalculoFolha,  
                    $this->hcmParameters->getNrorgTrabalho(), 
                    'VALIDASISTEMA',
                    $this->hcmParameters->getCdoperador() 
                );*/                
                
                MsgCalculo::getInstance()->setDados($this->nrcalculoFolha, $vinculo->getNrvinculom(), $nrorg, 'VALIDASISTEMA', DateUtil::getDataAtual());
                
                //Pessoa
                $this->pessoa = $this->entityManager->getRepository(Repositories::GPE_PESSOA)->retornaPessoaAtual(
                    $nrorg, $nrPessoa , $mesCompetencia
                );
                $nrParcNegocio = $this->pessoa->getNrparcnegocio();
                
                //Pais Pessoa
                $this->pessoa->pais = null;
                
                if($this->pessoa->historico->getCdpais()){
                    $cdPais = $this->pessoa->historico->getCdpais();
                    $conditions = "AND CDPAIS = $cdPais AND (NRORG = $nrorg OR NRORG = $nrorgPadrao)";
                    $pais = $this->entityManager->getRepository(Repositories::PAIS)->obtemTodosPaises($conditions);
                    
                    if($pais){
                        $this->pessoa->pais = $pais[0];
                    }
                }
                
                //Nacionalidade Pessoa
                $this->pessoa->nacionalidade = null;
                
                if($this->pessoa->historico->getNrnacionalid()){
                    
                    $nacionalidade = $this->entityManager->getRepository(Repositories::GPE_NACIONALIDADE)->findOneBy(array('nrorg' => array($nrorg, $nrorgPadrao),
                    'nrnacionalidade' => $this->pessoa->historico->getNrnacionalid()));
                    
                    $this->pessoa->nacionalidade = $nacionalidade;
                }
                
                //Endereco Vinculo
                $enderecoPessoa = $this->entityManager->getRepository(Repositories::ENDERECOPARC)->findOneBy(array('nrorg' => $nrorg,
                'nrparcnegocio' => $nrParcNegocio,'cdtipoendereco'=> Estruturacao::ENDERECO_PRINCIPAL));
                
                $this->enderecoPessoa = $enderecoPessoa;
                
                //Conta Corrente Vinculo
                $contCorrParcPessoa = $this->entityManager->getRepository(Repositories::CONTCORRPARC)->findOneBy(array('nrorg' => array($nrorg, $nrorgPadrao),
                'nrparcnegocio' => $nrParcNegocio));
                
                $this->contCorrParcPessoa = $contCorrParcPessoa;
                
                //Forma Comunicação Vinculo
                $objComunicacoesParcVinc = $this->entityManager->getRepository(Repositories::COMUNICAPARC)->findBy(array('nrorg' => $nrorg,
                'nrparcnegocio' => $nrParcNegocio));
                
                $this->pessoa->telefone = null;
                $this->pessoa->email = null;
                $this->pessoa->ddd = null;
                $this->pessoa->ramal = null;
    
                foreach ($objComunicacoesParcVinc as $formaComunicacao){
                    if ($formaComunicacao->getCdformacomu() ===  Estruturacao::FORMA_COMUNICACAO_TEL_PRINCIPAL) {
                        $this->pessoa->ddd = $formaComunicacao->getCdprefixcomuparc();
                        $this->pessoa->telefone = $formaComunicacao->getCdcomunicaparc();
                        $this->pessoa->ramal = '99999999';
                    }
                    if ($formaComunicacao->getCdformacomu() ===  Estruturacao::FORMA_COMUNICACAO_EMAIL) {
                        $this->pessoa->email = $formaComunicacao->getCdcomunicaparc();
                    }
                }
                
                $formacao = $this->entityManager->getRepository(Repositories::DES_FORMACAO)->findOneBy(array('nrorg' => $nrorg,
                'nrparcnegocio' => $nrParcNegocio));
                
                $this->pessoa->formacao = $formacao;
                
                //Dependentes
                $this->dependentes = $this->entityManager->getRepository(Repositories::FPA_DEPVINCULO)->findBy(
                array('nrvinculom' => $nrVinculom, 'nrorg' =>  $nrorg), array('nrtipodepende' => 'ASC'));
            
                //Vinculo Empregaticio
                $this->vinculoEmpreg = $this->entityManager->getRepository(Repositories::GPE_VINCULOEMPREG)->retornaVinculoEmpregaticio($vinculo->getNrvinculoempreg());
                
                //Situação Funcional
                $alteSituFunc = $this->entityManager->getRepository(Repositories::GPE_ALTESITUFUNC)->retornaUltimaSituacaoFuncional($nrorg, $nrVinculom, DateUtil::getUltimoDiaDoMes($mesCompetencia));
                if(is_object($alteSituFunc)){
                    $this->situFunc = $situacaoFuncional[$alteSituFunc->getNrsitufuncm()];
                   
                    if($alteSituFunc->getNrmotivoafasta()){
                        $motivoAfasta = $this->entityManager->getRepository(Repositories::GPE_MOTIVOAFASTA)->findOneBy(
                            array('nrmotivoafasta' => $alteSituFunc->getNrmotivoafasta(), 'nrorg' => array($nrorg, 0)));
                            
                        if($motivoAfasta){
                            if(!$motivoAfasta->getCdesocial()){
                                MsgCalculo::getInstance()->adicionaMensagem('Código do Esocial não esta cadastrado para o motivo de afastamento', MsgCalculo::ALERTA);
                            }
                            if($motivoAfasta->getCdesocial() == 21 && !$alteSituFunc->getDsobsaltsitfunc()){
                                MsgCalculo::getInstance()->adicionaMensagem('Situação funcional do vínculo sem observação cadastrada', MsgCalculo::ERRO);
                            }
                        }
                    }else{
                        $situAfastamento = array(12, 15, 16, 100012);
                        if((array_search($alteSituFunc->getNrsitufuncm(), $situAfastamento) != false || $this->situFunc->historico->getIdafastsitufunc() == 'S') && $alteSituFunc->getNrsitufuncm() != 13){
                            MsgCalculo::getInstance()->adicionaMensagem('Motivo de afastamento não esta cadastrado para a situação funcional do vínculo ', MsgCalculo::ERRO);
                        }
                    }
                }
                    
                $this->alteSituFunc = $alteSituFunc;
                
                //Escala
                $nrEscala = $vinculo->historico->getNrescalatrabm();
                if(!$this->escala->historico || $nrEscala != $this->escala->getNrescalatrabm()){
                    $escala = $this->entityManager->getRepository(Repositories::GPE_ESCALATRABM)->retornaEscalaTrab($nrEscala, $nrorg);
                    $escala->historico = $this->entityManager->getRepository(Repositories::GPE_ESCALATRABH)->retornaUltimoHistorico($nrEscala, $nrorg);
                    $this->escala = $escala;
                }

                //Ocupação
                $alteOcupacao = $this->entityManager->getRepository(Repositories::GPE_ALTEOCUPACAO)->retornaUltimaAlteracaoOcupacaoVinculo($nrorg, $mesCompetencia, $nrVinculom);
                $this->alteOcupacao = $alteOcupacao;
                
                if(!$this->ocupacao || $this->ocupacao->getNrocupacaom() != $ocupacao->getNrocupacaom()){
                    $ocupacao = $this->entityManager->getRepository(Repositories::GPE_OCUPACAOM)->retornaOcupacao($nrorg, $alteOcupacao->getNrocupacaom(), $mesCompetencia);
                    $this->ocupacao = $ocupacao;
                }
                
                //Salario
                $alteSalario = $this->entityManager->getRepository(Repositories::GPE_ALTESALARIO)->retornaAlteSalarioAtualPorVinculoModalidade($nrorg, $ultimoDiaMes, $nrVinculom, $vinculo->historico->getNrtpmodalidsal());
                $this->alteSalario = $alteSalario;
                
                //Ferias
                $ferias = $this->entityManager->getRepository(Repositories::FPA_FERIAS)->findBy(array('nrorg' => $nrorg, 'nrvinculom' => $nrVinculom), array('idcontrolferias' => 'DESC'));
                
                /* ------------------- ESTRUTURA LEGAL --------------------*/
                
                if(!$this->estruturaLegal || $this->estruturaLegal->getNrestruturam() != $nrEstrutLegal){    
                    $estruturaLegal = $this->entityManager->getRepository(Repositories::ESTRUTURAM)->retornaEstrutura($nrorg, $nrEstrutLegal, $mesCompetencia);
                    $historicoLegal = $this->entityManager->getRepository(Repositories::ESTRUTURAH)->retornaEstruturaHistorico($nrorg, $nrEstrutLegal, $mesCompetencia);
                    $estruturaLegal->historico = $historicoLegal;
                    
                    if($estruturaLegal->historico){
                        $nrParcNegocioEstrutLegal = $estruturaLegal->getNrparcnegocio();
                        
                        //Endereco Estrutura Legal
                        $enderecoEstrutLegal = $this->entityManager->getRepository(Repositories::ENDERECOPARC)->findOneBy(array('nrorg' => $nrorg,
                        'nrparcnegocio' => $nrParcNegocioEstrutLegal,'cdtipoendereco'=> Estruturacao::ENDERECO_PRINCIPAL));
                        
                        $estruturaLegal->endereco = $enderecoEstrutLegal;
                        
                        //Conta Corrente Estrutura Legal
                        $contCorrParcEstrutLegal = $this->entityManager->getRepository(Repositories::CONTCORRPARC)->findOneBy(array('nrorg' => array($nrorg, $nrorgPadrao),
                        'nrparcnegocio' => $nrParcNegocioEstrutLegal));
                        
                        $estruturaLegal->contaCorr = $contCorrParcEstrutLegal;
                        
                        //Forma Comunicação Estrutura Legal
                        $objComunicacoesParcEstrutLegal = $this->entityManager->getRepository(Repositories::COMUNICAPARC)->findBy(array('nrorg' => $nrorg,
                        'nrparcnegocio' => $nrParcNegocioEstrutLegal));
                        
                        $estruturaLegal->telefone = null;
                        $estruturaLegal->email = null;
                        $estruturaLegal->ddd = null;
                        $estruturaLegal->ramal = null;
            
                        foreach ($objComunicacoesParcEstrutLegal as $formaComunicacao){
                            if ($formaComunicacao->getCdformacomu() ===  Estruturacao::FORMA_COMUNICACAO_TEL_PRINCIPAL) {
                                $estruturaLegal->ddd = $formaComunicacao->getCdprefixcomuparc();
                                $estruturaLegal->telefone = $formaComunicacao->getCdcomunicaparc();
                                $estruturaLegal->ramal = '99999999';
                            }
                            if ($formaComunicacao->getCdformacomu() ===  Estruturacao::FORMA_COMUNICACAO_EMAIL) {
                                $estruturaLegal->email = $formaComunicacao->getCdcomunicaparc();
                            }
                        }
                        
                        $tipoEstruturaLegal = $this->entityManager->getRepository(Repositories::TIPOESTRUTURA)->findOneBy(array('nrorg' => array($nrorg, $nrorgPadrao),
                        'nrtipoestrutura' => $estruturaLegal->getNrtipoestrutura()));
                        
                        $estruturaLegal->tipoEstrutura = $tipoEstruturaLegal;
                        
                        //Processos Administrativos/Judiciais
                        $processosAdmJudLegal = $this->entityManager->getRepository(Repositories::GPE_PROCESSADMJUD)->findBy(array('nrorg' => $nrorg,
                        'nrestruturam' => $estruturaLegal->getNrestruturam()));
                        
                        $estruturaLegal->processosAdm = $processosAdmJudLegal;
                        
                        //Pontos de Acesso - Tipos de registo de ponto
                        $pontosAcesso = $this->entityManager->getRepository(Repositories::GPE_PONTOACESSO)->findBy(
                            array('nrorg' => $nrorg, 'nrestruturam' => $estruturaLegal->getNrestruturam(), 'idativo' => 'S')
                        );
                        $estruturaLegal->pontosAcesso = $pontosAcesso;
                        foreach ($pontosAcesso as $pontoAcesso) {
                            $tipoRegPonto = $this->entityManager->getRepository(Repositories::GPE_TPREGIPONTO)->findOneBy(
                                array('nrtpregiponto' => $pontoAcesso->getNrtpregiponto(), 'idativo' => 'S')
                            );
                            $estruturaLegal->tiposRegiPonto[] = $tipoRegPonto->getCdesocial();
                        }
                        
                        $this->estruturaLegal = $estruturaLegal;
                    }
                }
                
                /* ------------------- ESTRUTURA GERENCIAL --------------------*/
                
                if(!$this->estruturaGeren || $this->estruturaGeren->getNrestruturam() != $nrEstrutGeren){    
                    $estruturaGeren = $this->entityManager->getRepository(Repositories::ESTRUTURAM)->retornaEstrutura($nrorg, $nrEstrutGeren, $mesCompetencia);
                    $historicoGeren = $this->entityManager->getRepository(Repositories::ESTRUTURAH)->retornaEstruturaHistorico($nrorg, $nrEstrutGeren, $mesCompetencia);
                    $estruturaGeren->historico = $historicoGeren;
                    if($estruturaGeren->historico){
                        
                        $nrParcNegocioEstrutGeren = $estruturaGeren->getNrparcnegocio();
                        
                        //Endereco Estrutura Geren
                        $enderecoEstrutGeren = $this->entityManager->getRepository(Repositories::ENDERECOPARC)->findOneBy(array('nrorg' => $nrorg,
                        'nrparcnegocio' => $nrParcNegocioEstrutGeren,'cdtipoendereco'=> Estruturacao::ENDERECO_PRINCIPAL));
                        
                        $estruturaGeren->endereco = $enderecoEstrutGeren;
                        
                        //Conta Corrente Estrutura Geren
                        $contCorrParcEstrutGeren = $this->entityManager->getRepository(Repositories::CONTCORRPARC)->findOneBy(array('nrorg' => array($nrorg, $nrorgPadrao),
                        'nrparcnegocio' => $nrParcNegocioEstrutGeren));
                        
                        $estruturaGeren->contaCorr = $contCorrParcEstrutGeren;
            
                        //Forma Comunicação Estrutura Geren
                        $objComunicacoesParcEstrutGeren = $this->entityManager->getRepository(Repositories::COMUNICAPARC)->findBy(array('nrorg' => $nrorg,
                        'nrparcnegocio' => $nrParcNegocioEstrutGeren));
                        
                        $estruturaGeren->telefone = null;
                        $estruturaGeren->email = null;
                        $estruturaGeren->ddd = null;
                        $estruturaGeren->ramal = null;
            
                        foreach ($objComunicacoesParcEstrutGeren as $formaComunicacao){
                            if ($formaComunicacao->getCdformacomu() ===  Estruturacao::FORMA_COMUNICACAO_TEL_PRINCIPAL) {
                                $estruturaGeren->ddd = $formaComunicacao->getCdprefixcomuparc();
                                $estruturaGeren->telefone = $formaComunicacao->getCdcomunicaparc();
                                $estruturaGeren->ramal = '99999999';
                            }
                            if ($formaComunicacao->getCdformacomu() ===  Estruturacao::FORMA_COMUNICACAO_EMAIL) {
                                $estruturaGeren->email = $formaComunicacao->getCdcomunicaparc();
                            }
                        }
                        
                        $fatorRiscoEstrutGeren = $this->entityManager->getRepository(Repositories::SST_RELESTRUTRISCO)->findOneBy(array('nrorg' => $nrorg,
                        'nrestruturam' => $estruturaGeren->getNrestruturam()));
                        
                        $processosAdmJudGeren = $this->entityManager->getRepository(Repositories::GPE_PROCESSADMJUD)->findBy(array('nrorg' => $nrorg,
                        'nrestruturam' => $estruturaGeren->getNrestruturam()));
                        
                        $estruturaGeren->processosAdm = $processosAdmJudGeren;
                        
                        $estruturaGeren->fatorRisco = $fatorRiscoEstrutGeren;
                        $this->estruturaGeren = $estruturaGeren;
                        
                        $estruturaTom = $this->validacaoSistemaRepository->getEstruturaTomador($nrorg,$estruturaGeren->getNrestruturam(),$mesCompetencia);
                        $this->estruturaTom = $estruturaTom;
                    }
                }
                
                /* ------------------- ESTRUTURA SINDICAL --------------------*/
                
                if($nrEstrutSind != null){
                    if((!$this->estruturaSind || $this->estruturaSind->getNrestruturam() != $nrEstrutSind)){    
                        
                        $estruturaSind = $this->entityManager->getRepository(Repositories::ESTRUTURAM)->retornaEstrutura($nrorg, $nrEstrutSind, $mesCompetencia);
                        $historicoSind = $this->entityManager->getRepository(Repositories::ESTRUTURAH)->retornaEstruturaHistorico($nrorg, $nrEstrutSind, $mesCompetencia);
                        
                        $estruturaSind->historico = $historicoSind;
                        
                        if($estruturaSind->historico){
                            $nrParcNegocioEstrutSind = $estruturaSind->getNrparcnegocio();
                            
                            //Endereco Estrutura Sind
                            $enderecoEstrutSind = $this->entityManager->getRepository(Repositories::ENDERECOPARC)->findOneBy(array('nrorg' => $nrorg,
                            'nrparcnegocio' => $nrParcNegocioEstrutSind,'cdtipoendereco'=> Estruturacao::ENDERECO_PRINCIPAL));
                            
                            $estruturaSind->endereco = $enderecoEstrutSind;
                            
                            // CNPJ para estrutura Sind
                            $cdCNPJEstruturaSind = $estruturaSind->historico->getcdcnpjestrut();
                            if(!$cdCNPJEstruturaSind){
                                MsgCalculo::getInstance()->adicionaMensagem('Estrutura Sindical não possui CNPJ', MsgCalculo::ERRO);
                            }
                            
                            //Conta Corrente Estrutura Sind
                            $contCorrParcEstrutSind = $this->entityManager->getRepository(Repositories::CONTCORRPARC)->findOneBy(array('nrorg' => array($nrorg, $nrorgPadrao),
                            'nrparcnegocio' => $nrParcNegocioEstrutSind));
                            
                            $estruturaSind->contaCorr = $contCorrParcEstrutSind;
                            
                            //Forma Comunicação Estrutura Sind
                            $objComunicacoesParcEstrutSind = $this->entityManager->getRepository(Repositories::COMUNICAPARC)->findBy(array('nrorg' => $nrorg,
                            'nrparcnegocio' => $nrParcNegocioEstrutSind));
                            
                            $estruturaSind->telefone = null;
                            $estruturaSind->email = null;
                            $estruturaSind->ddd = null;
                            $estruturaSind->ramal = null;
                
                            foreach ($objComunicacoesParcEstrutSind as $formaComunicacao){
                                if ($formaComunicacao->getCdformacomu() ===  Estruturacao::FORMA_COMUNICACAO_TEL_PRINCIPAL) {
                                    $estruturaSind->ddd = $formaComunicacao->getCdprefixcomuparc();
                                    $estruturaSind->telefone = $formaComunicacao->getCdcomunicaparc();
                                    $estruturaSind->ramal = '99999999';
                                }
                                if ($formaComunicacao->getCdformacomu() ===  Estruturacao::FORMA_COMUNICACAO_EMAIL) {
                                    $estruturaSind->email = $formaComunicacao->getCdcomunicaparc();
                                }
                            }
                            $this->estruturaSind = $estruturaSind;
                        }
                    }
                }else{
                    MsgCalculo::getInstance()->adicionaMensagem('Estrutura Sindical não cadastrada para a Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
                }
                    
                $this->validaEstrutura($this->estruturaLegal);
                $this->validaEstrutura($this->estruturaGeren);
                if($this->estruturaSind)
                $this->validaEstrutura($this->estruturaSind);
                if($this->estruturaTom)
                    $this->validaEstrutura($this->estruturaTom);
                $this->validaPessoa();
                $this->validaVinculo();
                $this->validaOcupacao();
                $this->validaEscala();
                
                MsgCalculo::getInstance()->salvaMensagens(true);
                
            }else if($dataSet['DSORIGMSG'] === 'ERROSCALCULO_VALIDA' || !$dataSet['DSORIGMSG']){
                
                $this->entityManager->getRepository(Repositories::FPA_MSGCALCULO)->limpaMsgCalculoVinculo(
                    $this->nrcalculoFolha, 
                    $nrVinculom, 
                    $nrorg, 
                    'ERROSCALCULO_VALIDA'
                );
                
                /*$this->entityManager->getRepository(Repositories::FPA_MSGCALCULO)->limpaMsgCalculoProcesso(
                    $this->nrcalculoFolha,  
                    $this->hcmParameters->getNrorgTrabalho(), 
                    'ERROSCALCULO_VALIDA',
                    $this->hcmParameters->getCdoperador() 
                );*/                
                
                MsgCalculo::getInstance()->setDados($this->nrcalculoFolha, $vinculo->getNrvinculom(), $nrorg, 'ERROSCALCULO_VALIDA', DateUtil::getDataAtual());

                // Salário 
                $alteSalario = $this->entityManager->getRepository(Repositories::GPE_ALTESALARIO)->retornaAlteSalarioAtualPorVinculoModalidade($nrorg, $ultimoDiaMes, $nrVinculom, $vinculo->historico->getNrtpmodalidsal());
                $this->alteSalario = $alteSalario;
                if($this->alteSalario){
                    $salarioBase = $this->alteSalario[0]->getVrSalario();
                }else{
                    MsgCalculo::getInstance()->adicionaMensagem('Vínculo sem salário cadastrado', MsgCalculo::ALERTA);
                }
                
                // Item de Cálculo Folha
                $itensCalculo = $this->entityManager->getRepository(Repositories::FPA_ITECALCFOLHA)->findBy(
                    array('nrorg' => $nrorg, 'nrvinculom' =>  $nrVinculom, 'nrcalculofolha' => $this->nrcalculoFolha)
                );                
                $this->iteCalcFolha = $itensCalculo;
                if($itensCalculo){
                    
                    $this->valorEventos = array();
                    $this->rubricaeSocial = array();
                    $this->referenciaEventos = array();
                    $this->valorFerias = array();
                    $this->referenciaFerias = array();
                    $proventos = $descontos = 0;
                    $this->incideFGTS = 0;
                    $this->incideINSS = 0;
                    $this->incideIRRF = 0;
                    $this->incideFerias = 0;
                    $this->vlrMaxINSS = 0;
                    $this->grupoIncide = array();
                    $feriasComp = NULL;
                    $this->EventoFerias = NULL;
                    $itemCalcFerias; 
                    $possuiPrimParte;
                    $possuiSegParte;
                    $eventosErrados = '';
                    $calcIRRF;
                    $dadosTabela;
                    $nrtabelafolha = 1;
                    $cdeSocial9219 = false;
                    $semEnvio1010 = array();
                    $dadosEnvio;
                    
                    
                    foreach($itensCalculo as $key => $item){
                        
                        $eventom = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->retornaEvento(
                            $item->getNreventom(), $nrorg, $nrorgPadrao, $mesCompetencia
                        );    
                        
                        $naturezarubrica = $this->retornaNaturezaRubrica($eventom, $nrorgPadrao);
                        if($naturezarubrica){
                            if($naturezarubrica->getCdesocial() == 9219)
                                $cdeSocial9219 = true;
                                
                            $dadosEnvio = $this->verificaEnvio1010Eventos($this->rubricaeSocial, $nrtipomovimento, $nrEstrutLegal, $nrorg, $mesCompetencia, $nrVinculom);
                        }
                        
                        if($eventom){
                            
                            $this->valorEventos[$eventom->getNreventom()] = $item->getVreventofolha();
                            $this->referenciaEventos[$eventom->getNreventom()] = $item->getVrreffolha();
                            $this->eventos[$eventom->getNreventom()] = $eventom;
                            // É somado o total de proventos e descontos da folha
                            if($eventom->getIdtipoevento() === 'PROVENTO' && $item->getidevendemoncalc() != 'S'){
                                $this->valorEventos['PROVENTO'] += $item->getVreventofolha();
                            }else if($eventom->getIdtipoevento() === 'DESCONTO' && $item->getidevendemoncalc() != 'S'){
                                $this->valorEventos['DESCONTO'] += $item->getVreventofolha();
                            }
                            
                        }
                    }
                    
                    
                    
                    //  beneficiarios do vínculo
                    $dadosDependBeneficiario = array();
                    $beneficiario = $this->entityManager->getRepository(Repositories::VAB_BENEFICIARIO)->findBy(array('nrorg' => $nrorg, 'nrvinculom' => $nrVinculom));
                    if($beneficiario){
                        foreach($beneficiario as $item){
                            if($item->getNrpessoa() != $nrPessoa){
                                $dependenteBeneficio =  $this->entityManager->getRepository(Repositories::GPE_PESSOA)->retornaPessoaAtual(
                                    $nrorg, $item->getNrpessoa() , $mesCompetencia
                                );
                                if($dependenteBeneficio){
                                    $dadosDependBeneficiario[$item->getNrpessoa()]["NOME"] = $dependenteBeneficio->historico->getNmpessoa();
                                    $dadosDependBeneficiario[$item->getNrpessoa()]["BENEFICIO"] = $item->getNrbeneficiom();
                                    $dadosDependBeneficiario[$item->getNrpessoa()]["DTNASCIMENTO"] = $dependenteBeneficio->historico->getDtnascpessoa();
                                    $dadosDependBeneficiario[$item->getNrpessoa()]["CPF"] = $dependenteBeneficio->historico->getNrcpfpessoa();
                                }
                            }
                        }
                    }
                    // Soma dos eventos que incidem no FGTS
                    $eventoFGTS;
                    $tipoIncideFGTS;
                    $eventosFGTS = array(FpatipoassoceveEntity::ASSOC_INCID_FGTS => FpatipoincideEntity::INC_FGTS_CALC,
                                    FpatipoassoceveEntity::ASSOC_INCID_FGTS_RESC => FpatipoincideEntity::INC_FGTS_RESC);
                    foreach ($eventosFGTS as $key => $value) {
                        if($this->valorEventos[$key]){
                            $eventoFGTS = $key;
                            $tipoIncideFGTS = $value;
                        }
                    }
                    $baseFGTS = $this->validacaoSistemaRepository->getSomaValorEventosPorIncidencia($tipoIncideFGTS, $nrorgPadrao, $nrorg, $nrVinculom, $nrtipomovimento, $nrTpModalidadeCalc, $mesCompetencia, $nrOcorrenciaCalc);
                    $this->incideFGTS = $baseFGTS[0]['VREVENTOFOLHA'];
                    
                    // Soma dos eventos que incidem no INSS
                    $eventoINSS;
                    $tipoIncideINSS;
                    $eventosINSS = array(FpatipoassoceveEntity::ASSOC_INCID_INSS => FpatipoincideEntity::INC_INSS_CALC,
                                    FpatipoassoceveEntity::ASSOC_INCID_INSS_PRO_LABORE => FpatipoincideEntity::INC_INSS_CALC,
                                    FpatipoassoceveEntity::ASSOC_INCID_INSS_AUTONOMO => FpatipoincideEntity::INC_INSS_CALC,
                                    FpatipoassoceveEntity::ASSOC_INCID_INSS_RESC => FpatipoincideEntity::INC_INSS_RESC);
                    foreach ($eventosINSS as $key => $value) {
                        if($this->valorEventos[$key]){
                            $eventoINSS = $key;
                            $tipoIncideINSS = $value;
                        }
                    }
                    $baseINSS = $this->validacaoSistemaRepository->getSomaValorEventosPorIncidencia($tipoIncideINSS, $nrorgPadrao, $nrorg, $nrVinculom, $nrtipomovimento, $nrTpModalidadeCalc, $mesCompetencia, $nrOcorrenciaCalc);
                    $this->incideINSS = $baseINSS[0]['VREVENTOFOLHA'];
                    // Soma dos eventos que incidem no IRRF
                    $eventoIRRF;
                    $tipoIncideIRRF;
                    $eventosIRRF = array(FpatipoassoceveEntity::ASSOC_INCID_IRRF => FpatipoincideEntity::INC_IRRF_CALC,
                                    FpatipoassoceveEntity::ASSOC_INCID_IRRF_RESC => FpatipoincideEntity::INC_IRRF_RESC);
                    foreach ($eventosIRRF as $key => $value) {
                        if($this->valorEventos[$key]){
                            $eventoIRRF = $key;
                            $tipoIncideIRRF = $value;
                        }
                    }
                    $baseIRRF = $this->validacaoSistemaRepository->getSomaValorEventosPorIncidencia($tipoIncideIRRF, $nrorgPadrao, $nrorg, $nrVinculom, $nrtipomovimento, $nrTpModalidadeCalc, $mesCompetencia, $nrOcorrenciaCalc);
                    $this->incideIRRF = $baseIRRF[0]['VREVENTOFOLHA'];
                    
                    // Retorna valor máximo da última faixa de INSS
                    $referencia = 0;
                    $vlrMaxINSS = FpafaixatabelaEntity::retornaValorUltimaFaixa(
                        999999999.00, FpatabelafolhaEntity::TAB_INSS, $mesCompetencia, $referencia
                    );
                    
                    // Retorna tipo de incidência, evento que incide, percentual, multiplicador e divisor de cálculo
                    $grupoIncide = $this->validacaoSistemaRepository->getGrupoIncidencia($nrorg, $nrEstrutLegal, $mesCompetencia);
                    
                    $soma;
                    foreach ($grupoIncide as $value) {
                        $this->grupoIncide[$value['NREVENTOM']] = $value;
                        $soma = $this->validacaoSistemaRepository->getSomaValorEventosPorIncidencia($this->grupoIncide[$value['NREVENTOM']]['NRTIPOINCIDE'], $nrorgPadrao, $nrorg, $nrVinculom, $nrtipomovimento, $nrTpModalidadeCalc, $mesCompetencia, $nrOcorrenciaCalc);   
                        $this->grupoIncide[$value['NREVENTOM']]['SOMA'] = $soma[0]['VREVENTOFOLHA'];
                    }
                    
                    $vrFap = $this->entityManager->getRepository(Repositories::ESTRUTURAH)->retornaEstruturaHistorico($nrorg, $nrEstrutLegal, $mesCompetencia)->getVrfap();
                    
                    // Retorna os dias trabalhados do vínculo e o número de dias considerados no salário
                    $nrEventos = FpatipoassoceveEntity::ASSOC_SALARIO_1.','.FpatipoassoceveEntity::ASSOC_SALARIO_2.','.FpatipoassoceveEntity::ASSOC_SOCIO.','.FpatipoassoceveEntity::ASSOC_AUTONOMO;
                    $diasTrabalhados = $this->validacaoSistemaRepository->getDiasTrabalhados($mesCompetencia, $nrorg, $nrVinculom, $nrEventos, $nrOcorrenciaCalc, $nrtipomovimento, $nrTpModalidadeCalc);
                    $diasTrabalhados = $diasTrabalhados[0];
                    
                    // Retorna a competência de início de férias e a competência anterior, se na competência atual o vínculo estiver de férias 
                    $dtFerias = $this->validacaoSistemaRepository->getPeriodoFerias($mesCompetencia, $nrorg, $nrVinculom);
                    
                    if($dtFerias){
                        
                        
                        $dtFerias = $dtFerias[0];
                        $this->segundaParte = 0.00;
                        $this->segundaParteFolha = 0.00;
                        $this->valorFerias = array();
                        $this->referenciaFerias = array();
                        $this->incideFerias = 0;
                        $this->calculoFerias = array();
                        $this->eventoFeriasFolha = 0;
                        // Possui primeira parte = 1 |Não possui primeira parte = 0
                        $possuiPrimParte = 0;
                        // Possui segunda parte = 1 | Não possui segunda parte = 0
                        $possuiSegParte = 0;
                        $retornoFerias = array();
                        
                        if($this->eventos[FpatipoassoceveEntity::ASSOC_FERIAS] || $this->eventos[FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE]){
                            $feriasComp = true;
                        }else{
                            $feriasComp = false;   
                        }
                        
                        // Parametros retornaFerias: $tipoIncidencia(FpatipoincideEntity::INC_SUBTOTAL_FERIAS), $nrorgPadrao, $nrorg, $nrVinculom, $nrtipomovimento, $nrtipomovimentoferias, $nrTpModalidadeCalc, $mesCompetencia, $nrOcorrenciaCalc
                        $retornoFerias = $this->retornaFerias(FpatipoincideEntity::INC_SUBTOTAL_FERIAS, $nrorgPadrao, $nrorg, $nrVinculom, $nrtipomovimento, $nrtipomovimentoferias, $nrTpModalidadeCalc, substr($dtFerias['COMPETENCIA1'], 0, 10), $nrOcorrenciaCalc);
                        $this->eventoFeriasFolha = $retornoFerias['EVENTOFERIASFOLHA'];
                        $this->valorFerias = $retornoFerias['VALORFERIAS'];
                        $this->incideFerias = $retornoFerias['INCIDEFERIAS'][0]['VREVENTOFOLHA'];
                    
                        
                        if($dtFerias['COMPETENCIA1'] === $dtFerias['COMPETENCIA4']){
                            // só possui uma parte nas ferias
                            $possuiPrimParte = 1;
                            $possuiSegParte = 0;
                            
                        }else{
                             
                            if($dtFerias['COMPETENCIA1'] === $dtFerias['COMPETENCIA3']){
                            // se a competencia de inicio for igual a competencia anterior do fim
            
                                // se o inicio for na competencia passada, a segunda parte está nesse mês
                                if(substr($dtFerias['COMPETENCIA1'], 0, 10) === DateUtil::setMonth($mesCompetencia, (DateUtil::getMes($mesCompetencia) - 1))->format('d/m/Y')){
                                    
                                    
                                   $this->segundaParte =  $this->valorFerias[3040] - $this->incideFerias;
                                   $this->segundaParteFolha = $this->valorEventos[FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FE_2_P];
                                   $possuiSegParte = 1;
                                   $possuiPrimParte = 0;
                                    
                                }else{
                                    $possuiSegParte = 0;
                                    $possuiPrimParte = 1;
                                }    
                            
                            }else{
                            // se a competencia de inicio for diferente da competencia anterior do fim
                                // se o inicio das ferias for nessa competencia, não tem segunda parte
                                if($dtFerias['COMPETENCIA1'] === $mesCompetencia){
                                    $possuiSegParte = 0;  
                                    $possuiPrimParte = 1;
                                
                                // se o inicio for na competencia anterior, a segunda parte esta no mes de competência
                                }else if(substr($dtFerias['COMPETENCIA1'], 0, 10) === DateUtil::subtraiIntervalo($mesCompetencia, 1, DateUtil::MES)->format('d/m/Y')){
                                    
                                    $this->segundaParte =  $this->valorEventos[FpatipoassoceveEntity::ASSOC_LIQUIDO] - $this->incideFerias;
                                    $this->segundaParteFolha = $this->valorEventos[FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FE_2_P];
                                    $possuiSegParte = 1;
                                    $possuiPrimParte = 0;
                                   
                                // se o inicio fom na competencia retrasada, a segunda foi na anterior
                                }else if(substr($dtFerias['COMPETENCIA1'], 0,10) === DateUtil::subtraiIntervalo($mesCompetencia, 2, DateUtil::MES)->format('d/m/Y')){
                                    $possuiSegParte = 0;
                                    $possuiPrimParte = 0;
                                }
                            }
                        }
                        
                        $eventosFerias = array( FpatipoassoceveEntity::ASSOC_FERIAS,
                                                FpatipoassoceveEntity::ASSOC_FERIAS_DOBRA,
                                                FpatipoassoceveEntity::ASSOC_MEDIA_FERIAS_1_PARTE,
                                                FpatipoassoceveEntity::ASSOC_ADIC_FERIAS,
                                                FpatipoassoceveEntity::ASSOC_ADIC_FERIAS,
                                                FpatipoassoceveEntity::ASSOC_ADIC_FERIAS_DOBRA,
                                                FpatipoassoceveEntity::ASSOC_MEDIA_ADIC_FERIAS_1_PARTE,
                                                FpatipoassoceveEntity::ASSOC_ABONO_PECUNIARIO,
                                                FpatipoassoceveEntity::ASSOC_MEDIA_ABONO_PECUNIARIO,
                                                FpatipoassoceveEntity::ASSOC_ADIC_ABONO,
                                                FpatipoassoceveEntity::ASSOC_MEDIA_ADIC_ABONO,
                                                FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE,
                                                FpatipoassoceveEntity::ASSOC_MEDIA_FERIAS_2_PARTE,
                                                FpatipoassoceveEntity::ASSOC_MEDIA_ADIC_FERIAS_2_PARTE);
                        $contador = 0;                        
                        foreach($eventosFerias as $evento){
                            if($this->valorEventos[$evento] != NULL && $this->valorFerias[$evento] != NULL){
                                if($this->valorEventos[$evento] != $this->valorFerias[$evento]){
                                    $eventosErrados .= ($eventosErrados === '') ? $evento.'-'.$this->eventos[$evento]->historico->getNmeventoh() : ', '.$evento.'-'.$this->eventos[$evento]->historico->getNmeventoh();
                                }
                            }
                        }
                    }
                    // Cálculo da base de IRRF
                    $bsINSS;
                    $vlINSS;
                    $eventosBaseINSS = array(FpatipoassoceveEntity::ASSOC_INCID_INSS,
                                    FpatipoassoceveEntity::ASSOC_INCID_INSS_PRO_LABORE,
                                    FpatipoassoceveEntity::ASSOC_INCID_INSS_AUTONOMO,
                                    FpatipoassoceveEntity::ASSOC_INCID_INSS_RESC);
                    $eventosValorINSS = array(FpatipoassoceveEntity::ASSOC_INSS_CALC,
                                    FpatipoassoceveEntity::ASSOC_INSS_SOCIOS,
                                    FpatipoassoceveEntity::ASSOC_INSS_AUTONOMO,
                                    FpatipoassoceveEntity::ASSOC_INSS_RESCISAO);
                    foreach ($eventosBaseINSS as $value) {
                        if($this->valorEventos[$value]){
                            $bsINSS = $this->valorEventos[$value];
                        }  
                    };
                    foreach ($eventosValorINSS as $value) {
                        if($this->valorEventos[$value]){
                            $vlINSS = $this->valorEventos[$value];
                        }
                    }
                    if($bsINSS && $vlINSS){
                        $calcIRRF = $this->validacaoSistemaRepository->getBaseIRRF($nrorg, $bsINSS, $vlINSS, $mesCompetencia, $nrVinculom);
                        $calcIRRF = $calcIRRF[0]['VALOR'];
                    }else{
                        $calcIRRF = false;
                    }
                    
                    // inicia a classe FpaincideventoEntity
                    $incide_eventos = new FpaincideventoEntity($this->entityManager, $this->hcmParameters);
                    
                    // Horas Extras
                    $itemHoraExtra;
                    $horaExtaForcada = '';
                    $eventosHE = $incide_eventos->getEventos($mesCompetencia, FpatipoincideEntity::INC_REFLEXO_HORA_EXTRA);
                    foreach($eventosHE as $evento){
                        if($this->valorEventos[$evento]){
                            $itemHoraExtra = $this->retornaItemCalculo($this->iteCalcFolha, $evento);
                            if($itemHoraExtra->getIdrefevalorcalc() != 'NORMAL'){
                                $horaExtaForcada .= ($horaExtaForcada === '') ? $evento.'-'.$this->eventos[$evento]->historico->getNmeventoh() : ', '.$evento.'-'.$this->eventos[$evento]->historico->getNmeventoh();
                            }
                            
                        }
                    }    
                    
                    // Adicional Noturno
                    $itemAdicNoturno;
                    $itemForcado = '';
                    $eventosAdic = $incide_eventos->getEventos($mesCompetencia, FpatipoincideEntity::INC_REFLEXO_ADIC_NOTURNO);
                    foreach($eventosAdic as $evento){
                        if($this->valorEventos[$evento]){
                            $itemAdicNoturno = $this->retornaItemCalculo($this->iteCalcFolha, $evento);
                            if($itemAdicNoturno->getIdrefevalorcalc() != 'NORMAL'){
                                $itemForcado .= ($itemForcado === '') ? $evento.'-'.$this->eventos[$evento]->historico->getNmeventoh() : ', '.$evento.'-'.$this->eventos[$evento]->historico->getNmeventoh();
                            }
                            
                        }
                    }
                    
                    // parâmetros: base FGTS e valor FGTS
                    $this->validaValorFGTS($this->valorEventos[FpatipoassoceveEntity::ASSOC_FGTS], $this->valorEventos[FpatipoassoceveEntity::ASSOC_INCID_FGTS]);
                    
                    // parâmetros: faixa parametrizada, base INSS, valor INSS do evento, valor máximo de INSS da última faixa. 
                    $this->validaValorINSS($this->referenciaEventos[FpatipoassoceveEntity::ASSOC_INSS_CALC], $this->incideINSS, $this->valorEventos[FpatipoassoceveEntity::ASSOC_INSS_CALC], $vlrMaxINSS);
                    
                    // parâmetros: soma do total dos proventos e total dos proventos do evento 
                    $this->validaTotalProventos(round($this->valorEventos['PROVENTO'], 2), round($this->valorEventos[FpatipoassoceveEntity::ASSOC_PROVENTOS], 2));
                    
                    // parâmetros: soma do total dos descontos e totaldos descontos do evento
                    $this->validaTotalDescontos(round($this->valorEventos['DESCONTO'], 2), round($this->valorEventos[FpatipoassoceveEntity::ASSOC_DESCONTOS], 2));
                    
                    // parâmetros: líquido do evento, soma do total de proventos e soma do total de descontos
                    $this->validaLiquido($this->valorEventos[FpatipoassoceveEntity::ASSOC_LIQUIDO], $this->valorEventos['PROVENTO'], $this->valorEventos['DESCONTO']);
                    
                    // parâmetros: referência e valor de faltas dia e referência e valor de faltas dia do mês anterior  
                    if(($this->referenciaEventos[FpatipoassoceveEntity::ASSOC_FALTAS_DIA] != NULL || $this->referenciaEventos[FpatipoassoceveEntity::ASSOC_FALTAS_DIA_MES_ANT] != NULL) && $salarioBase){
                        $this->validaFaltasDias($this->referenciaEventos[FpatipoassoceveEntity::ASSOC_FALTAS_DIA], $this->valorEventos[FpatipoassoceveEntity::ASSOC_FALTAS_DIA], $this->referenciaEventos[FpatipoassoceveEntity::ASSOC_FALTAS_DIA_MES_ANT], $this->valorEventos[FpatipoassoceveEntity::ASSOC_FALTAS_DIA_MES_ANT], $salarioBase);
                    }
                    
                    // parâmetros: soma de todos os eventos incidentes do FGTS e valor do FGTS do evento
                    $this->validaCalculoFGTS($this->incideFGTS, $this->valorEventos[$eventoFGTS]);
                    
                    // parâmetros: soma de todos os eventos incidentes do INSS e o valor do INSS do evento
                    $this->validaCalculoINSS($this->incideINSS, $this->valorEventos[$eventoINSS]);
                    
                    // parâmetros: soma de todos os eventos incidentes do IRRF e valor do IRRF do evento
                    $this->validaCalculoIRRF($this->incideIRRF, $this->valorEventos[$eventoIRRF]);
                    
                    // parâmetros: Array de grupo de incidência (soma dos eventos, percentual, multiplicador, divisor), valor do INSS empresa do evento 
                    $this->validaINSSEmpresa($this->grupoIncide[FpatipoassoceveEntity::ASSOC_INSS_EMPRESA], $this->valorEventos[FpatipoassoceveEntity::ASSOC_INSS_EMPRESA]);
                    
                    // parâmetros: Array de grupo de incidência (soma dos eventos, percentual, multiplicador, divisor), valor do INSS SAT do evento 
                    $this->validaINSSsat($this->grupoIncide[FpatipoassoceveEntity::ASSOC_INSS_ACID_TRAB], $this->valorEventos[FpatipoassoceveEntity::ASSOC_INSS_ACID_TRAB], $vrFap);
                    
                    // parâmetros: Array de grupo de incidência (soma dos eventos, percentual, multiplicador, divisor), valor do INSS Terceiros do evento 
                    $this->validaINSSTerceiros($this->grupoIncide[FpatipoassoceveEntity::ASSOC_INSS_TERCEIROS], $this->valorEventos[FpatipoassoceveEntity::ASSOC_INSS_TERCEIROS]);
                
                    // parâmetros: Array com dias trabalhados e dias do evento salário
                    $this->validaDiasTrabalhados($diasTrabalhados);
                    
                    // parâmetros: variável boolean que informa se há evento de férias no cálculo de folha da competência atual (true)
                    $this->validaEventoFerias($feriasComp);
                        
                    // parâmetros: subtotal de ferias do cálculo de férias, eventos que incidem em férias, subtotal de ferias do cálcuo de férias, variável de conferencia da existência da primeira parte, calculo de segunda parte, segunda parte da folha, variável de conferência de existência de segunda parte 
                    $this->validaValorFerias($this->valorFerias[FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FERIAS], $this->incideFerias, $this->valorEventos[FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FERIAS], $possuiPrimParte, round($this->segundaParte, 2), $this->segundaParteFolha, $possuiSegParte, $eventosErrados);
                
                    // parâmetros: valor do evento de cálculo de IRRF e o cálculo de IRRF 
                    $this->validaBaseCalculoIRRF($this->valorEventos[$eventoIRRF], $calcIRRF);
                    
                    // parâmetros: variável string com nome dos eventos de hora extra forcados
                    $this->validaHoraExtra($horaExtaForcada);
                    
                    // parâmetros: variável string com nome dos eventos de adicional noturno forcados
                    $this->validaAdicionalNoturno($itemForcado);
                    
                    // parâmetros: registro de beneficiario relacionado ao vínculo, variável boolean que informa se há lancamento de evento com cdesocial = 9219 e código do vinculo
                    $this->validaBeneficioeSocial($beneficiario, $cdeSocial9219, $nrVinculom);
                    
                    // parâmetros: dados dos dependentes beneficiários e variável boolean que informa se há lancamento de evento com cdesocial = 9219
                    $this->validaDadosBeneficiarioDependente($dadosDependBeneficiario, $cdeSocial9219);
                    
                    // parâmetros: nome do evento e dados do envio
                    $this->validaLancamentosEnvioS1010($dadosEnvio, $nrtipomovimento);
                    
                    // parâmetros: eventos que possuem natureza da rubrica, valor dos eventos eventos e tipo de movimento
                    $this->validaLiquidoEventosRubricaESocial($this->rubricaeSocial, $this->valorEventos, $nmtipomovimento);
                    
                }
                
                MsgCalculo::getInstance()->salvaMensagens(false);
            
            }else if($dataSet['DSORIGMSG'] === 'ERROESOPERIOD_VALIDA' || !$dataSet['DSORIGMSG']){
                // validações do tipo de movimento mensal
                if($this->nrcalculoFolha){
                    
                    $this->entityManager->getRepository(Repositories::FPA_MSGCALCULO)->limpaMsgCalculoVinculo(
                        $this->nrcalculoFolha, 
                        $nrVinculom, 
                        $nrorg, 
                        'ERROESOPERIOD_VALIDA'
                    );              
                    
                    MsgCalculo::getInstance()->setDados($this->nrcalculoFolha, $vinculo->getNrvinculom(), $nrorg, 'ERROESOPERIOD_VALIDA', DateUtil::getDataAtual());
                    
                    // comparação bases INSS ESocial
                    /*
                    *   Evento base folha : 3070 | incidência : 2
                    *   Evento base rescisão : 3190 | incidência : 5
                    */
                    $params = array('TPINCIDENCIAESO'  => 'INSS',
                                    'NRCALCULOFOLHA'   => $this->nrcalculoFolha,
                                    'NREVENTOMBASE'    => '3070,3190',
                                    'INCIDENCIABASE'   => '2,5',
                                    'NRVINCULOM'       => $nrVinculom,
                                    'NRORG'            => $nrorg,
                                    'CDINCIDESOCIAL'   => '11');
                    
                    $valoresBaseINSS_ESO = $this->validacaoSistemaRepository->getBaseCalculoEncargoEsocial($params);
                    if(!empty($valoresBaseINSS_ESO)){
                        $this->validaBaseCalculoEncargoMensalEsocial($valoresBaseINSS_ESO['VRSOMA'], $valoresBaseINSS_ESO['VRBASE'], $params['TPINCIDENCIAESO'], $valoresBaseINSS_ESO['NREVENTOBASE']);
                    }
                    
                    // comparação bases IRRF ESocial
                    /*
                    *   Evento base folha : 3080 | incidência : 1
                    *   Evento base rescisão : 3200 | incidência : 4
                    */
                    $params = array('TPINCIDENCIAESO'  => 'IRRF',
                                    'NRCALCULOFOLHA'   => $this->nrcalculoFolha,
                                    'NREVENTOMBASE'    => '3080,3200',
                                    'INCIDENCIABASE'   => '1,4',
                                    'NRVINCULOM'       => $nrVinculom,
                                    'NRORG'            => $nrorg,
                                    'CDINCIDESOCIAL'   => '11');
                                    
                    $valoresBaseIRRF_ESO = $this->validacaoSistemaRepository->getBaseCalculoEncargoEsocial($params);
                    if(!empty($valoresBaseIRRF_ESO)){
                        $this->validaBaseCalculoEncargoMensalEsocial($valoresBaseIRRF_ESO['VRSOMA'], $valoresBaseIRRF_ESO['VRBASE'], $params['TPINCIDENCIAESO'], $valoresBaseIRRF_ESO['NREVENTOBASE']);
                    }
                    
                    // comparação bases FGTS ESocial
                    /*
                    *   Evento base folha : 3060 | incidência : 3
                    *   Evento base rescisão : 3180 | incidência : 6
                    */
                    $params = array('TPINCIDENCIAESO'  => 'FGTS',
                                    'NRCALCULOFOLHA'   => $this->nrcalculoFolha,
                                    'NREVENTOMBASE'    => '3060,3180',
                                    'INCIDENCIABASE'   => '3,6',
                                    'NRVINCULOM'       => $nrVinculom,
                                    'NRORG'            => $nrorg,
                                    'CDINCIDESOCIAL'   => '11');
                                    
                    $valoresBaseFGTS_ESO = $this->validacaoSistemaRepository->getBaseCalculoEncargoEsocial($params);
                    if(!empty($valoresBaseFGTS_ESO)){
                        $this->validaBaseCalculoEncargoMensalEsocial($valoresBaseFGTS_ESO['VRSOMA'], $valoresBaseFGTS_ESO['VRBASE'], $params['TPINCIDENCIAESO'], $valoresBaseFGTS_ESO['NREVENTOBASE']);
                    }
                }
                
                $nrcalculoDecimoTerceiro = FPA::determinaNrCalculoFolha('4');
                // validações do tipo de movimento 13° salário
                if($nrcalculoDecimoTerceiro){
                    
                    // comparação bases INSS ESocial
                    /*
                    *   Evento base folha : 3130 | incidência : 20
                    *   Evento base rescisão : 3211 | incidência : 8
                    */
                    $params = array('TPINCIDENCIAESO'  => 'INSS',
                                    'NRCALCULOFOLHA'   => $nrcalculoDecimoTerceiro,
                                    'NREVENTOMBASE'    => '3130,3211',
                                    'INCIDENCIABASE'   => '20,8',
                                    'NRVINCULOM'       => $nrVinculom,
                                    'NRORG'            => $nrorg,
                                    'CDINCIDESOCIAL'   => '12');
                    
                    $valoresBaseINSS_ESO = $this->validacaoSistemaRepository->getBaseCalculoEncargoEsocial($params);
                    if(!empty($valoresBaseINSS_ESO)){
                        $this->validaBaseCalculoEncargoDecTerEsocial($valoresBaseINSS_ESO['VRSOMA'], $valoresBaseINSS_ESO['VRBASE'], $params['TPINCIDENCIAESO'], $valoresBaseINSS_ESO['NREVENTOBASE']);
                    }
                    
                    // comparação bases IRRF ESocial
                    /*
                    *   Evento base folha : 3140 | incidência : 19
                    *   Evento base rescisão : 3212 | incidência : 7
                    */
                    $params = array('TPINCIDENCIAESO'  => 'IRRF',
                                    'NRCALCULOFOLHA'   => $nrcalculoDecimoTerceiro,
                                    'NREVENTOMBASE'    => '3140,3212',
                                    'INCIDENCIABASE'   => '19,7',
                                    'NRVINCULOM'       => $nrVinculom,
                                    'NRORG'            => $nrorg,
                                    'CDINCIDESOCIAL'   => '12');
                                    
                    $valoresBaseIRRF_ESO = $this->validacaoSistemaRepository->getBaseCalculoEncargoEsocial($params);
                    if(!empty($valoresBaseIRRF_ESO)){
                        $this->validaBaseCalculoEncargoDecTerEsocial($valoresBaseIRRF_ESO['VRSOMA'], $valoresBaseIRRF_ESO['VRBASE'], $params['TPINCIDENCIAESO'], $valoresBaseIRRF_ESO['NREVENTOBASE']);
                    }
                    
                    // comparação bases FGTS ESocial
                    /*
                    *   Evento base folha : 3120 | incidência : 21
                    *   Evento base rescisão : 3210 | incidência : 9
                    */
                    $params = array('TPINCIDENCIAESO'  => 'FGTS',
                                    'NRCALCULOFOLHA'   => $nrcalculoDecimoTerceiro,
                                    'NREVENTOMBASE'    => '3120,3210',
                                    'INCIDENCIABASE'   => '21,9',
                                    'NRVINCULOM'       => $nrVinculom,
                                    'NRORG'            => $nrorg,
                                    'CDINCIDESOCIAL'   => '12');
                                    
                    $valoresBaseFGTS_ESO = $this->validacaoSistemaRepository->getBaseCalculoEncargoEsocial($params);
                    if(!empty($valoresBaseFGTS_ESO)){
                        $this->validaBaseCalculoEncargoDecTerEsocial($valoresBaseFGTS_ESO['VRSOMA'], $valoresBaseFGTS_ESO['VRBASE'], $params['TPINCIDENCIAESO'], $valoresBaseFGTS_ESO['NREVENTOBASE']);
                    }
                }
                
                
                MsgCalculo::getInstance()->salvaMensagens(false);
                
            }
            MsgCalculo::getInstance()->clear();
        }
    }
    
    public function retornaNaturezaRubrica($evento, $nrorgPadrao){
        $naturezarubrica = $this->entityManager->getRepository(Repositories::NATUREZARUBRICA)->findOneBy(array('nrorg' => $nrorgPadrao, 'nrnaturubr' => $evento->historico->getnrnaturubr()));
        if($naturezarubrica){
            $this->rubricaeSocial[$evento->getNreventom()]['NRNATURUBR'] = $naturezarubrica->getNrnaturubr();
            $this->rubricaeSocial[$evento->getNreventom()]['CDESOCIAL'] = $naturezarubrica->getCdesocial();
            $this->rubricaeSocial[$evento->getNreventom()]['NMEVENTOH'] = $evento->historico->getNmeventoh();
            return $naturezarubrica;
        }
    }
    
    public function retornaItemCalculo($itensCalculo, $evento){
        $retorno;
        foreach($itensCalculo as $item){
            if($item->getNreventom() === $evento){
                $retorno = $item;
            }
        }
        
        return $retorno;
    }
    
    public function verificaEnvio1010Eventos($rubricaeSocial, $nrtipomovimento, $nrEstrutLegal, $nrorg, $mesCompetencia, $nrVinculom){
        $nrtpambiente;
        $estrutMatriz;
        $estruturas = $this->eSocialRepository->getEstruturasESocial($nrorg, $mesCompetencia, $this->hcmParameters->getTipoEstruturaLegalOrg(), 'T', '');
        foreach($estruturas as $estrutura){
            if($estrutura['NRESTRUTURAM'] == $nrEstrutLegal && $estrutura['IDMATRIZ'] == 'N'){
                $retorno;
                foreach ($estruturas as $item) {
                    if($item['CDCNPJESTRUT'] == $estrutura['CDCNPJEMPREGADOR']){
                        $retorno = $item;
                    }
                }
                $estrutMatriz = $retorno['NRESTRUTURAM'];
                $nrtpambiente = $retorno['NRTPAMBIENTE'];
            }else if($estrutura['NRESTRUTURAM'] == $nrEstrutLegal && $estrutura['IDMATRIZ'] == 'S'){
                $nrtpambiente = $estrutura['NRTPAMBIENTE'];
                $estrutMatriz = $estrutura['NRESTRUTURAM'];
            }
        }
        foreach($rubricaeSocial as $evento => $rub){
            
            $envio[$evento]['NMEVENTOH'] = $rub['NMEVENTOH'];
            $envio[$evento]['ENVIO'] = $this->entityManager->getRepository(Repositories::ESO_ENVIOCADASTROS)->getEnviosPorNomeEvento(
                                            $nrorg, 'S-1010', $estrutMatriz, $nrtpambiente, 'S', $evento, $nrtipomovimento
                                        );
        }
        return $envio;
    }
    
    // public function parametrizaESocialEventosProvDesc(){
    //     foreach ($eventos as  $nrevento => $evento) {
    //         if($nrevento = '1015' && $nrtipomovimento != 10){
                
    //         }else if($nrevento = '1290' && $nrtipomovimento == 1){
                
    //         }else if(($nrevento = '1310' || $nrevento = '1510' || $nrevento = '1520') && $nrtipomovimento == 1){
                
    //         }else{
                
    //         }
    //     }
    // }
    
    public function retornaFerias($tipoIncidencia, $nrorgPadrao, $nrorg, $nrVinculom, $nrtipomovimfolha, $nrtipomovimferias, $nrTpModalidadeCalc, $mesCompetencia, $nrOcorrenciaCalc){
        $calcferias;
        $valorferias;
        $referenciaferias;
        $eventoFeriasFolha;
        $incideFerias;
        
        
        $calcfolha = $this->entityManager->getRepository(Repositories::FPA_CALCULOFOLHA)->retornaCalculoFolha(
                        $nrorg, $nrtipomovimfolha, $nrTpModalidadeCalc, $nrOcorrenciaCalc, DateUtil::getDataDeString($mesCompetencia), DateUtil::getDataDeString($mesCompetencia)
                    );
        $calcfolha = $calcfolha[0];            
        
        // Retorna ítem de cálculo de folha
        $itensCalculo = $this->entityManager->getRepository(Repositories::FPA_ITECALCFOLHA)->findBy(
                    array('nrorg' => $nrorg, 'nrvinculom' =>  $nrVinculom, 'nrcalculofolha' => $this->nrcalculoFolha)
                );
                
        // Retorna o ítem de férias da folha
        foreach($itensCalculo as $item){
            if($item->getnreventom() === FpatipoassoceveEntity::ASSOC_FERIAS || $item->getnreventom() === FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE){
                $eventoFeriasFolha = $item->getVreventofolha();
            }
        }
        
        // Retorna cálculo de férias 
        $calcferias = $this->entityManager->getRepository(Repositories::FPA_CALCULOFOLHA)->retornaCalculoFolha(
                        $nrorg, $nrtipomovimferias, $nrTpModalidadeCalc, $nrOcorrenciaCalc, DateUtil::getDataDeString($mesCompetencia), DateUtil::getDataDeString($mesCompetencia)
                    );
        $calcferias = $calcferias[0];
                    
        // Retorna os item de cálculo de férias  
        $itemCalcFerias = $itensCalculo = $this->entityManager->getRepository(Repositories::FPA_ITECALCFOLHA)->findBy(
            array('nrorg' => $nrorg, 'nrvinculom' =>  $nrVinculom, 'nrcalculofolha' => $calcferias->getNrcalculofolha())
        );
        
        // Retorna o valor e a referência dos eventos de férias
        foreach($itemCalcFerias as $key => $item){
        
            $eventom = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->retornaEvento(
                $item->getNreventom(), $nrorg, $nrorgPadrao, DateUtil::getDataDeString($mesCompetencia)
            );    
            
            if($eventom){
                $valorferias[$eventom->getNreventom()] = $item->getVreventofolha();
                $referenciaferias[$eventom->getNreventom()] = $item->getVrreffolha();
            }
        }
        // Retorna a soma dos eventos incidentes no movemento de férias
        $incideFerias = $this->validacaoSistemaRepository->getSomaValorEventosPorIncidencia(
                            $tipoIncidencia, $nrorgPadrao, $nrorg, $nrVinculom, $nrtipomovimferias, $nrTpModalidadeCalc, $mesCompetencia, $nrOcorrenciaCalc
                        );
                        
        $retorno = array('CAUCULOFERIAS'     => $calcferias,
                         'VALORFERIAS'       => $valorferias,
                         'REFERENCIAFERIAS'  => $referenciaferias,
                         'EVENTOFERIASFOLHA' => $eventoFeriasFolha,
                         'INCIDEFERIAS'      => $incideFerias);
        return $retorno;
        
    }
    
    public function validaValorFGTS($vlrFGTS, $vlrBaseFGTS){
        if( round(($vlrBaseFGTS * 0.08), 2) != round($vlrFGTS, 2) ){    
            MsgCalculo::getInstance()->adicionaMensagem('O valor do FGTS ('.round($vlrFGTS, 2).') não corresponde a 8% da base de cálculo', MsgCalculo::ERRO);
        }    
    }
    
    public function validaValorINSS($faixa, $vlrBaseINSS, $vlrINSS, $vlrMaxINSS){
        if(round(($vlrBaseINSS * $faixa/100), 2) != round($vlrINSS, 2)){
            if (!(($vlrBaseINSS * $faixa/100) > $vlrINSS && $vlrINSS === $vlrMaxINSS)){
                MsgCalculo::getInstance()->adicionaMensagem('O valor do INSS ('.round($vlrINSS).') não corresponde a '.$faixa.'% da base de cálculo', MsgCalculo::ERRO);
            }
        }
    }
    
    public function validaTotalProventos($proventos, $totalProventos){
        if($proventos != $totalProventos){
            MsgCalculo::getInstance()->adicionaMensagem('O valor do evento "Total de proventos" ('.$totalProventos.') não corresponde à soma dos proventos ('.$proventos.').', MsgCalculo::ERRO);
        }
    }

    public function validaTotalDescontos($descontos, $totalDescontos){
        if($descontos != $totalDescontos){
            MsgCalculo::getInstance()->adicionaMensagem('O valor do evento "Total de descontos" ('.$totalDescontos.') não corresponde à soma dos descontos ('.$descontos.').', MsgCalculo::ERRO);
        }
    }
    
    public function validaLiquido($baseLiquido, $proventos, $descontos){
        if( round($baseLiquido, 2) != round(($proventos - $descontos), 2) ){
           MsgCalculo::getInstance()->adicionaMensagem('O valor do evento "Liquido" ('.round($baseLiquido, 2).') não corresponde à diferença entre soma dos proventos ('.$proventos.') com a soma dos descontos('.$descontos.').', MsgCalculo::ERRO);
        }
    }
    
    public function validaFaltasDias($refFaltasDias, $vlrFaltasDias, $refFaltasDiasAnt, $vlrFaltasDiasAnt, $salarioBase){
        $refFaltasDias = ($refFaltasDias === NULL) ? 0 : $refFaltasDias;
        $vrlFaltasDias = ($vrlFaltasDias === NULL) ? 0 : $vrlFaltasDias;
        $refFaltasDiasAnt = ($refFaltasDiasAnt === NULL) ? 0 : $refFaltasDiasAnt;
        $vrlFaltasDiasAnt = ($vrlFaltasDiasAnt === NULL) ? 0 : $vrlFaltasDiasAnt;
        $vlrTotalFaltas = $vlrFaltasDiasAnt + $vlrFaltasDias;
        
        if($vlrTotalFaltas != round((($salarioBase/30)*($refFaltasDias + $refFaltasDiasAnt)), 2)){
            MsgCalculo::getInstance()->adicionaMensagem('O valor de faltas ('.$vlrTotalFaltas.') não corresponde ao cálculo (salário mensal / 30) * (dias de falta).', MsgCalculo::ERRO);
        }
    }
    
    public function validaCalculoFGTS($totalFGTS, $valorFGST){
        if(round($valorFGST, 2) != round($totalFGTS, 2)){
            MsgCalculo::getInstance()->adicionaMensagem('A base de cálculo do FGTS não corresponde a soma de todos os eventos incidentes.', MsgCalculo::ERRO);
        }
    }
    
    public function validaCalculoINSS($totalINSS, $valorINSS){
        if(round($valorINSS, 2) != round($totalINSS, 2)){
            MsgCalculo::getInstance()->adicionaMensagem('A base de cálculo do INSS não corresponde a soma de todos os eventos incidentes.', MsgCalculo::ERRO);
        }
    }
    
    public function validaCalculoIRRF($totalIRRF, $valorIRRF){
        if(round($valorIRRF, 2) != round($totalIRRF, 2)){
            MsgCalculo::getInstance()->adicionaMensagem('A base de cálculo do IRRF não corresponde a soma de todos os eventos incidentes.', MsgCalculo::ERRO);
        }
    }
    
    public function validaINSSEmpresa($arrayIncidenciaEmp, $vlrINSSEmpresa){
        $totalINSSEmpresa = (($arrayIncidenciaEmp['SOMA'] * $arrayIncidenciaEmp['VRMULTIPLIC'])/$arrayIncidenciaEmp['VRDIVIDE'])*$arrayIncidenciaEmp['VRPERCENT']/100;
        if(round($totalINSSEmpresa, 2) != round($vlrINSSEmpresa, 2)){
            MsgCalculo::getInstance()->adicionaMensagem('O valor do INSS Empresa não corresponde ao valor (base de INSS * % da contribuição patronal parametrizada para a empresa).', MsgCalculo::ERRO);
        }
    }
    
    public function validaINSSsat($arrayIncidenciaSAT, $vlrINSSsat, $vrFap){
        $totalINSSsat = ((($arrayIncidenciaSAT['SOMA'] * $arrayIncidenciaSAT['VRMULTIPLIC'])/$arrayIncidenciaSAT['VRDIVIDE'])*$arrayIncidenciaSAT['VRPERCENT']/100);
        $totalINSSsat = round($totalINSSsat * $vrFap, 2);
        if($totalINSSsat != round($vlrINSSsat, 2)){
            MsgCalculo::getInstance()->adicionaMensagem('O valor do INSS SAT não corresponde ao valor (base de INSS * % da contribuição patronal parametrizada para a empresa).', MsgCalculo::ERRO);
        }
    }
    
    public function validaINSSTerceiros($arrayIncidenciaTerc, $vlrINSSTerceiros){
        $totalINSSTerceiros = (($arrayIncidenciaTerc['SOMA'] * $arrayIncidenciaTerc['VRMULTIPLIC'])/$arrayIncidenciaTerc['VRDIVIDE'])*$arrayIncidenciaTerc['VRPERCENT']/100;
        if(round($totalINSSTerceiros, 2) != $vlrINSSTerceiros){
            MsgCalculo::getInstance()->adicionaMensagem('O valor do INSS Terceiros não corresponde ao valor (base de INSS * % da contribuição patronal parametrizada para a empresa).', MsgCalculo::ERRO);
        }
    }
    
    public function validaDiasTrabalhados($arrayDiasTrabalhados){
        if($arrayDiasTrabalhados['DIAS_SALARIO_ITEM'] != $arrayDiasTrabalhados['DIAS_QUERY_TRABALHADOS']){
            MsgCalculo::getInstance()->adicionaMensagem('O valor do salário mês não está proporcional aos dias trabalhados (Verificar possíveis problemas: admissão, rescisão ou férias do vínculo na competência).', MsgCalculo::ALERTA);
        }
    }
    
    public function validaEventoFerias($feriasComp){
        if($feriasComp === false ){
            MsgCalculo::getInstance()->adicionaMensagem('Funcionário com situação funcional igual a Férias, e sem o evento de férias na folha ou sem cálculo de folha.', MsgCalculo::ERRO);
        }
    }
    
    public function validaValorFerias($valorFerias, $incideFerias, $valorFeriasFolha, $possuiPrimParte, $segundaParte, $segundaParteFolha, $possuiSegParte, $eventosErrados){
        
        if($possuiPrimParte === 1){    
            if($valorFerias != $incideFerias){
                MsgCalculo::getInstance()->adicionaMensagem('O subtotal da primeira parte das férias não corresponde à soma dos eventos incidentes de férias.', MsgCalculo::ERRO);
            }
            if($valorFerias != $valorFeriasFolha){
                MsgCalculo::getInstance()->adicionaMensagem('O subtotal da primeira parte das férias não corresponde ao valor no evento de férias da folha. O(s) evento(s) ('.$eventosErrados.') está(ão) com divergência de valor.', MsgCalculo::ERRO);
            }
        }
        
            
        if($possuiSegParte === 1){
            if($segundaParte != $segundaParteFolha){
                MsgCalculo::getInstance()->adicionaMensagem('O subtotal da segunda parte das férias não corresponde ao valor no evento de férias da folha. O(s) evento(s) ('.$eventosErrados.') está(ão) com divergência de valor.', MsgCalculo::ERRO);
            }
        }
    }
    
    public function validaBaseCalculoIRRF($calculoIRRFFolha, $calcIRRF){
        if($calcIRRF){
            $calculoIRRFFolha = !$calculoIRRFFolha ? 0.0 : $calculoIRRFFolha;
            if(round($calculoIRRFFolha, 2) != round($calcIRRF, 2)){
                MsgCalculo::getInstance()->adicionaMensagem('O valor da base de cálculo de IRRF não corresponde com o valor do seu evento na folha.', MsgCalculo::ERRO);
            }
        }
    }
    
    public function validaHoraExtra($horaExtaForcada){
        if($horaExtaForcada != ''){
            MsgCalculo::getInstance()->adicionaMensagem('O(s) evento(s) de hora extra ('.$horaExtaForcada.') foi(foram) forçado(s).', MsgCalculo::ALERTA);
        }
    }
    
    public function validaAdicionalNoturno($itemForcado){
        if($itemForcado != ''){
            MsgCalculo::getInstance()->adicionaMensagem('O(s) evento(s) de adicional noturno ('.$itemForcado.') foi(foram) forçado(s).', MsgCalculo::ALERTA);
        }
    }
    
    public function validaBeneficioeSocial($beneficiario, $cdeSocial9219, $nrvinculom){
        if($cdeSocial9219 == true && !$beneficiario){
            MsgCalculo::getInstance()->adicionaMensagem('Vínculo '.$nrvinculom.' possui lançamento de eventos com rubrica do eSocial 9219 e não possui cadastro em nenhum benefício.', MsgCalculo::ALERTA);
        }
    }
    
    public function validaDadosBeneficiarioDependente($dadosDependBeneficiario, $cdeSocial9219){
        foreach ($dadosDependBeneficiario as $index => $dependente) {
            if(!$dependente['CPF'] && $cdeSocial9219 == true){
                MsgCalculo::getInstance()->adicionaMensagem('Dependente '.$index.'-'.$dependente['NOME'].' está vinculado ao benefício '.$dependente['BENEFICIO'].' e está sem CPF cadastrado.', MsgCalculo::ALERTA);
            }
            if(!$dependente['DTNASCIMENTO'] && $cdeSocial9219 == true){
                MsgCalculo::getInstance()->adicionaMensagem('Dependente '.$index.'-'.$dependente['NOME'].' está vinculado ao benefício '.$dependente['BENEFICIO'].' e está sem data de nascimento cadastrado.', MsgCalculo::ALERTA);
            }
        }
    }
    
    public function validaLancamentosEnvioS1010($dadosEnvio, $movimento){
        foreach ($dadosEnvio as $evento => $dados) {
            if(!$dados['ENVIO']){
                MsgCalculo::getInstance()->adicionaMensagem('O evento '.$evento.'-'.$dados['NMEVENTOH'].' não possui envios S-1010 para o movimento '.$movimento.'.', MsgCalculo::ALERTA);
            }
        }
    }
    
    public function validaLiquidoEventosRubricaESocial($naturezarubrica, $eventos, $nmtipomovimento){
        $valida = true;
        if($eventos[FpatipoassoceveEntity::ASSOC_LIQUIDO]){
            foreach ($naturezarubrica as $nrevento => $natureza) {
                if($eventos[$nrevento] != 0){
                    $valida = false;
                }
            }
        }
        if($valida){
            MsgCalculo::getInstance()->adicionaMensagem('O vínculo possui líquido e não possui nenhum evento com rubrica do eSocial com valor acima de zero para o movimento '.$nmtipomovimento.'.', MsgCalculo::ALERTA);
        }
    }
    
    public function validaBaseCalculoEncargoMensalEsocial($somaBase, $baseEventos, $encargo, $evento){
       $somaBase = round($somaBase, 2);
       $baseEventos = round($baseEventos, 2);
       if($somaBase != $baseEventos){
            if($encargo == 'INSS'){
                $mensagem = 'Base de Cálculo do Salário de Contribuição Mensal do eSocial (valor: '.$somaBase.') difere em '.($baseEventos - $somaBase).' da Base de INSS MENSAL do sistema (evento: '.$evento.'|valor: '.$baseEventos.').';
            }else{
                $mensagem = 'Base de Cálculo de '.$encargo.' (valor: '.$somaBase.') do eSocial difere em '.($baseEventos - $somaBase).' da Base de '.$encargo.' do sistema  (evento: '.$evento.'|valor: '.$baseEventos.').';
            }
            MsgCalculo::getInstance()->adicionaMensagem($mensagem, MsgCalculo::ERRO);
        }
    }
    
    public function validaBaseCalculoEncargoDecTerEsocial($somaBase, $baseEventos, $encargo, $evento){
        $somaBase = round($somaBase, 2);
        $baseEventos = round($baseEventos, 2);
        if($somaBase != $baseEventos){
            if($encargo == 'INSS'){
                $mensagem = ' Base de Calculo da Contrib. Prev. sobre 13º Salario do eSocial (valor: '.$somaBase.') difere em '.($baseEventos - $somaBase).'da Base de INSS 13º do sistema (evento: '.$evento.'|valor: '.$baseEventos.').';
            }else{
                $mensagem = 'Base de Cálculo de '.$encargo.' sobre 13º Salario do eSocial (valor: '.$somaBase.') difere em '.($baseEventos - $somaBase).' da Base de '.$encargo.' 13º do sistema (evento: '.$evento.'|valor: '.$baseEventos.').';
            }
            MsgCalculo::getInstance()->adicionaMensagem($mensagem, MsgCalculo::ERRO);
        }
    }
    
    public function validaEstrutura($estrutura){
        $nrTipoEstrutura = $estrutura->getNrtipoestrutura();
        
        /* ------------------- ESTRUTURA LEGAL --------------------*/
        if($nrTipoEstrutura == $this->hcmParameters->getTipoEstruturaLegalOrg()){
            
            //Classificação Tributaria
            if($this->tipoMsg != "A") { 
                if(!$estrutura->historico->getNrclasstribut()){
                    MsgCalculo::getInstance()->adicionaMensagem('Classificação tributária não está cadastrada para Estrutura Legal '.$estrutura->historico->getNmestruturah(), MsgCalculo::ERRO);
                }
            }
            
            //Tipo Estrutura
            if(is_object($estrutura->tipoEstrutura)){
                if(!$estrutura->tipoEstrutura->getNrtplotatribut()){
                    if($this->tipoMsg != "A") 
                    MsgCalculo::getInstance()->adicionaMensagem('Tipo de lotação tributária não está cadastrado para o Tipo de estrutura '.$estrutura->tipoEstrutura->getNmtipoestrutura(), MsgCalculo::ERRO);
                }
            }else{
                if($this->tipoMsg != "A") 
                MsgCalculo::getInstance()->adicionaMensagem('Tipo de estrutura não está cadastrado para Estrutura Legal '.$estrutura->historico->getNmestruturah(), MsgCalculo::ERRO);
            }
            
            //Pontos de Acesso
            if($this->tipoMsg != "E") { 
                if(empty($estrutura->pontosAcesso)) {
                    MsgCalculo::getInstance()->adicionaMensagem('Ponto de acesso não está cadastrado para Estrutura Legal '.$estrutura->historico->getNmestruturah(), MsgCalculo::ALERTA);
                } else {
                    //Tipo de Registro de Ponto
                    if(!isset($estrutura->tiposRegiPonto)){
                        MsgCalculo::getInstance()->adicionaMensagem('Tipo de ponto não está cadastrado para Estrutura Legal '.$estrutura->historico->getNmestruturah(), MsgCalculo::ALERTA);
                    }
                }
            }
            
        }
        /* ------------------- ESTRUTURA GERENCIAL --------------------*/
        else if($nrTipoEstrutura == $this->hcmParameters->getTipoEstruturaGerencialOrg()){
            
            //Fator de risco
            if($this->tipoMsg != "A") { 
                if(!is_object($estrutura->fatorRisco)){
                    MsgCalculo::getInstance()->adicionaMensagem('Fator de risco não está cadastrado para Estrutura Gerencial '.$estrutura->historico->getNmestruturah(), MsgCalculo::ERRO);
                }
            }
        }
        /* ------------------- ESTRUTURA SINDICAL --------------------*/
        else if($nrTipoEstrutura == 10){
            
        }else if($nrTipoEstrutura == 7 || $nrTipoEstrutura == $this->hcmParameters->getTipoEstruturaLegalOrg()){
            if($this->tipoMsg != "A")  
                if(!$estrutura->historico->getCdfpas())
                    MsgCalculo::getInstance()->adicionaMensagem('FPAS não está cadastrado para Estrutura '.$estrutura->historico->getNmestruturah(), MsgCalculo::ERRO);
            if($this->tipoMsg != "A") 
                if(!$estrutura->historico->getCdterceiro())
                    MsgCalculo::getInstance()->adicionaMensagem('Código de Terceiros não está cadastrado para Estrutura '.$estrutura->historico->getNmestruturah(), MsgCalculo::ERRO);
        }
        
        //Processos
        if($this->tipoMsg != "E") { 
            if(count($estrutura->processosAdm) > 0){
                foreach($estrutura->processosAdm as $processosGeren){
                    
                    //Administrativo
                    if($processosGeren->getCdprocessadmjud() == 1){
                        if(count($processosGeren->getCdprocessadmjud()) != 17){
                            MsgCalculo::getInstance()->adicionaMensagem('Processo Administrativo '.$processosGeren->getCdprocessadmjud().' deve ter o tamanho de 17 algarismos', MsgCalculo::ALERTA);
                        }
                    }
                    //Judicial
                    if($processosGeren->getCdprocessadmjud() == 2){
                        if(count($processosGeren->getCdprocessadmjud()) != 20){
                            MsgCalculo::getInstance()->adicionaMensagem('Processo Judicial '.$processosGeren->getCdprocessadmjud().' deve ter o tamanho de 20 algarismos', MsgCalculo::ALERTA);
                        }
                    }
                }
            }
        }
    }
    
    public function validaPessoa(){
        
        if($this->tipoMsg != "A") { 
        
            if(!$this->pessoa->historico->getNrcpfpessoa()){
                MsgCalculo::getInstance()->adicionaMensagem('CPF não está cadastrado para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
            }
            
            if(!$this->pessoa->historico->getIdsexopessoa()){
                MsgCalculo::getInstance()->adicionaMensagem('Sexo não está cadastrado para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
            }
            
            if(!$this->pessoa->historico->getNrracapessoa()){
                MsgCalculo::getInstance()->adicionaMensagem('Raça não está cadastrada para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
            }
            if(!$this->pessoa->historico->getNrgrauinstr()){
                MsgCalculo::getInstance()->adicionaMensagem('Grau de instrução não está cadastrado para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
            }
            
            if(!$this->pessoa->historico->getDtnascpessoa()){
                MsgCalculo::getInstance()->adicionaMensagem('Data de nascimento não está cadastrada para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
            }
            
            if(!$this->pessoa->historico->getCdpais()){
                MsgCalculo::getInstance()->adicionaMensagem('Falta cadastro de País de origem para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
            }
            
            if($this->pessoa->historico->getCdpais() == '0055' && !$this->pessoa->historico->getCdmunicipio()){
                MsgCalculo::getInstance()->adicionaMensagem('Falta cadastro de Município de origem para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
            }
            
            //Pais
            if($this->pessoa->pais){
                if(!$this->pessoa->pais['CDESOCIAL']){
                    MsgCalculo::getInstance()->adicionaMensagem('Falta cadastro do código do Esocial para o país '.$this->pessoa->pais['CDPAIS'].' - '.$this->pessoa->pais['NMPAIS'], MsgCalculo::ERRO);
                }
            }
            
            //Nacionalidade
            if($this->pessoa->nacionalidade){
                if(!$this->pessoa->nacionalidade->getCdpais()){
                    MsgCalculo::getInstance()->adicionaMensagem('Falta cadastro de país para a nacionalidade '.$this->pessoa->nacionalidade->getNrnacionalidade().' - '.$this->pessoa->nacionalidade->getDsnacionalidade(), MsgCalculo::ERRO);
                }
            }else{
                MsgCalculo::getInstance()->adicionaMensagem('Nacionalidade não está cadastrada para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
            }
        }
        
        if($this->tipoMsg != "E") {
            if(!$this->pessoa->historico->getNrpispaseppes() && $this->vinculo->getNrtipovinculom() != 2){
                MsgCalculo::getInstance()->adicionaMensagem('PIS não está cadastrado para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
            }
            
            if(!$this->pessoa->historico->getSgestado()){
            MsgCalculo::getInstance()->adicionaMensagem('Falta cadastro de Estado de origem para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ALERTA);
            }
            
            if(!$this->pessoa->historico->getCdmunicipio() && $this->pessoa->historico->getCdpais() != '0055'){
                MsgCalculo::getInstance()->adicionaMensagem('Falta cadastro de Município de origem para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ALERTA);
            }
        }
        
        //CTPS
        if($this->pessoa->historico->getNrctpspessoa() || $this->pessoa->historico->getNrseriectpspes() || $this->pessoa->historico->getSgufctpspes()){
            
            if($this->tipoMsg != "A") { 
                if(!$this->pessoa->historico->getNrctpspessoa()){
                    MsgCalculo::getInstance()->adicionaMensagem('Número CTPS não está cadastrado para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
                }
                
                if(!$this->pessoa->historico->getNrseriectpspes()){
                    MsgCalculo::getInstance()->adicionaMensagem('Série CTPS não está cadastrada para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
                }
                
                if(!$this->pessoa->historico->getSgufctpspes()){
                    MsgCalculo::getInstance()->adicionaMensagem('UF CTPS não está cadastrado para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
                }
            }    
        }
        
        //RG
        if($this->pessoa->historico->getNrrgpessoa() || $this->pessoa->historico->getCdexrgpessoa()){
            
            if($this->tipoMsg != "A") {
                if(!$this->pessoa->historico->getNrrgpessoa()){
                    MsgCalculo::getInstance()->adicionaMensagem('RG não está cadastrado para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
                }
                
                if(!$this->pessoa->historico->getCdexrgpessoa()){
                    MsgCalculo::getInstance()->adicionaMensagem('Órgão Expedidor do RG não está cadastrado para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
                }
            }    
        }
        
        //RNE
        if($this->pessoa->historico->getNrdocuestrang() 
        //|| $this->pessoa->historico->getDsexpdocestr() || $this->pessoa->historico->getDsclassestrang()
        || $this->pessoa->historico->getNranochegapais()){
            
            if($this->tipoMsg != "A") {
                if(!$this->pessoa->historico->getNrdocuestrang()){
                    MsgCalculo::getInstance()->adicionaMensagem('Número do RNE não está cadastrado para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
                }
                
                /*if(!$this->pessoa->historico->getDsexpdocestr()){
                    MsgCalculo::getInstance()->adicionaMensagem('Órgão Expedidor do RNE não está cadastrado para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
                }
                
                if(!$this->pessoa->historico->getDsclassestrang()){
                    MsgCalculo::getInstance()->adicionaMensagem('Classificação trabalhador estrangeiro não está cadastrada para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
                }*/
                
                if(!$this->pessoa->historico->getNranochegapais()){
                    MsgCalculo::getInstance()->adicionaMensagem('Data de chegada no país cadastrada para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ERRO);
                }
            }
        }
        
        
        //CNH
        if($this->tipoMsg != "E") {
            if($this->pessoa->historico->getNrcarthabpes() || $this->pessoa->historico->getDthabcartpes() 
            || $this->pessoa->historico->getDscateghabcart() || $this->pessoa->historico->getDtvalhabcartpes()){
                
                if(!$this->pessoa->historico->getNrcarthabpes()){
                    MsgCalculo::getInstance()->adicionaMensagem('Número de habilitação não está cadastrado para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ALERTA);
                }
                
                if(!$this->pessoa->historico->getDthabcartpes()){
                    MsgCalculo::getInstance()->adicionaMensagem('Data de habilitação não está cadastrada para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ALERTA);
                }
                
                if(!$this->pessoa->historico->getDscateghabcart()){
                    MsgCalculo::getInstance()->adicionaMensagem('Categoria de habilitação não está cadastrada para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ALERTA);
                }
                
                if(!$this->pessoa->historico->getDtvalhabcartpes()){
                    MsgCalculo::getInstance()->adicionaMensagem('Validade de habilitação não está cadastrada para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ALERTA);
                }
            }
        }
        
        if(is_object($this->enderecoPessoa)){
            if($this->tipoMsg != "A") {
                if(!$this->enderecoPessoa->getCdlogradouro()){
                    MsgCalculo::getInstance()->adicionaMensagem('Endereço sem tipo de logradouro cadastrado', MsgCalculo::ERRO);
                }
                
                if(!$this->enderecoPessoa->getDsendereco()){
                    MsgCalculo::getInstance()->adicionaMensagem('Endereço sem logradouro cadastrado', MsgCalculo::ERRO);
                }
                
                if(!$this->enderecoPessoa->getNrimovelendereco()){
                    MsgCalculo::getInstance()->adicionaMensagem('Endereço sem número cadastrado', MsgCalculo::ERRO);
                }
                
                if(!$this->enderecoPessoa->getNrcependereco()){
                    MsgCalculo::getInstance()->adicionaMensagem('Endereço sem CEP cadastrado', MsgCalculo::ERRO);
                }
                
                if(!$this->enderecoPessoa->getCdmunicipio()){
                    MsgCalculo::getInstance()->adicionaMensagem('Endereço sem município cadastrado', MsgCalculo::ERRO);
                }
                
                if(!$this->enderecoPessoa->getSgestado()){
                    MsgCalculo::getInstance()->adicionaMensagem('Endereço sem estado cadastrado', MsgCalculo::ERRO);
                }
            }
        }else{
            if($this->tipoMsg != "E") 
            MsgCalculo::getInstance()->adicionaMensagem('Endereço não está cadastrado para Pessoa '.$this->pessoa->getNrpessoa(), MsgCalculo::ALERTA);
        }
    }
    
    public function validaVinculo(){
        
        //CLT
        if($this->vinculo->getNrtipovinculom() == 1){
           if(!$this->vinculo->getDtopcaofgts()){
                MsgCalculo::getInstance()->adicionaMensagem('Vínculo sem opção FGTS cadastrada', MsgCalculo::ERRO);
           }
        }
        
        //Estagiario
        if($this->tipoMsg != "A") {
            if($this->vinculo->getNrtipovinculom() == 2){
                if(is_object($this->pessoa->formacao)){
                    if(!$this->pessoa->formacao->getDsinstituicao()){
                        MsgCalculo::getInstance()->adicionaMensagem('Estagiário sem Nome da Instituição de Ensino', MsgCalculo::ERRO);
                    }
                }else{
                    MsgCalculo::getInstance()->adicionaMensagem('Estagiário sem Instituição de Ensino', MsgCalculo::ERRO);
                }
                
                if(!$this->vinculo->getNrdiascontratoexp()){
                    MsgCalculo::getInstance()->adicionaMensagem('Estagiário sem Fim Contrato Exp no cadastro de Vinculo', MsgCalculo::ERRO);
                }
            }
        }    
        
        if($this->tipoMsg != "A") {
            if(is_object($this->vinculoEmpreg)){
                if(!$this->vinculoEmpreg->getNrcategesoc()){
                    MsgCalculo::getInstance()->adicionaMensagem('Vínculo empregatício sem categoria do trabalhador do E-social', MsgCalculo::ERRO);
                }
            }else{
                MsgCalculo::getInstance()->adicionaMensagem('Sem vínculo empregatício cadastrado', MsgCalculo::ERRO);
            }
        }
        
        //Dependentes
        if(count($this->dependentes) > 0){
            foreach ($this->dependentes as $dependente) {
                $pessoaDependente = $this->entityManager->getRepository(Repositories::GPE_PESSOA)->retornaPessoaAtual(
                    $this->hcmParameters->getNrorgTrabalho(), $dependente->getNrpessoa(), $this->hcmParameters->getDtCompetencia()
                );
                
                if(is_object($pessoaDependente->historico)){
                    $relacionaParc = $this->entityManager->getRepository(Repositories::RELACIONAPARC)->findOneBy(array('nrparcnegocio' => $this->pessoa->getNrparcnegocio(), 'nrparcnegrelac' => $pessoaDependente->getNrparcnegocio()));
                    if(is_object($relacionaParc)){
                        $tipoRelacionaParc = $relacionaParc->getNrtiporelaciona();
                    }else{
                        $tipoRelacionaParc = null;
                        MsgCalculo::getInstance()->adicionaMensagem('O dependente '.$pessoaDependente->historico->getNmpessoa().' não possui relacionamento com o vínculo '.$this->pessoa->historico->getNmpessoa(), MsgCalculo::ALERTA);
                    }
                    
                    if($this->tipoMsg != "E") {
                        if(!$pessoaDependente->historico->getDtnascpessoa()){
                            MsgCalculo::getInstance()->adicionaMensagem('Data de nascimento não está cadastrada para Dependente '.$pessoaDependente->historico->getNmpessoa(), MsgCalculo::ALERTA);
                        }
                    }
                    
                    //IMPOSTO DE RENDA
                    if($dependente->getNrtipodepende() == 2 && $pessoaDependente->historico->getDtnascpessoa()){
                        
                        $dtComp = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia());
                        $dataNascDependente = DateUtil::getDataDeString(substr($pessoaDependente->historico->getDtnascpessoa(), 0, 10) , DateUtil::FORMATO_BRASILEIRO, true);
                        $anoNasc = $dataNascDependente->format('Y');
    					$anoComp = $dtComp->format('Y');
    					$idadeDependente = abs($anoNasc - $anoComp) - 1;
    					$idadeMinCPF= $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->hcmParameters->getNrorgTrabalho(), $nrorgPadrao = $this->hcmParameters->getNrorgPadrao(), $this->hcmParameters->getDtCompetencia(), "IDADE_MIN_CPF_DEP");
                        if(!$idadeMinCPF){
                            $idadeMinCPF=0;}
                        if($idadeDependente >= $idadeMinCPF && !$pessoaDependente->historico->getNrcpfpessoa()){
                            $tipoDepentFilhoPensionista = array(3, 100001, 6);
                            if(array_search($tipoRelacionaParc, $tipoDepentFilhoPensionista) !== false){
                                if($this->tipoMsg != "A") 
                                MsgCalculo::getInstance()->adicionaMensagem('CPF não está cadastrado para Dependente '.$pessoaDependente->historico->getNmpessoa(), MsgCalculo::ERRO);
                            }else{
                                MsgCalculo::getInstance()->adicionaMensagem('CPF não está cadastrado para Dependente '.$pessoaDependente->historico->getNmpessoa(), MsgCalculo::ALERTA);
                            }   
                        }
                    }
                }    
            }
        }
        
        //Rescindidos
        if($this->vinculo->getDtrescisaovinc()){
            $tpDemissao = $this->entityManager->getRepository(Repositories::FPA_TPDEMISSAO)->retornaTipoDemissaoPorNr($this->_nrOrg, $this->_nrOrgPadrao, $this->vinculo->getNrtpdemissao())[0];
            
            if($this->tipoMsg != "A") {
                if($tpDemissao && !$tpDemissao->getCdesocial()){
                    MsgCalculo::getInstance()->adicionaMensagem('Código do e-Social não está cadastrado para Tipo de Demissão '.$tpDemissao->getNmtpdemissao(), MsgCalculo::ERRO);
                }
            }
            if($this->vinculo->getNrmotivoresc()){
                $motivoRescisao = $this->entityManager->getRepository(Repositories::GPE_MOTIVORESC)->findOneBy(array('nrorg' => array($this->nrorg, $this->nrorg_padrao), 'nrmotivoresc' => $this->vinculo->getNrmotivoresc()));
                if($this->tipoMsg != "E") {
                    if($motivoRescisao && !$motivoRescisao->getCdesocial()){
                        MsgCalculo::getInstance()->adicionaMensagem('Código do e-Social não está cadastrado para Motivo de rescisão '.$motivoRescisao->getNmmotivoresc(), MsgCalculo::ALERTA);
                    }
                }
            }
            
            //Aviso Previo.
            if($this->vinculo->getDtavisoprevio()){
                if(!$this->vinculo->getNrtpavipre() && ($this->vinculo->getDtrescisaovinc()->format('d/m/Y') != $this->vinculo->getDtavisoprevio()->format('d/m/Y') || $this->vinculo->getNrtpdemissao() == 5)){
                    MsgCalculo::getInstance()->adicionaMensagem('Tipo de Aviso Prévio não esta cadastrado para o vínculo', MsgCalculo::ERRO);
                }
            }
            
            
        }
        
        //Situação funcional 
        if($this->tipoMsg != "A") {
            if(!$this->alteSituFunc){
                 MsgCalculo::getInstance()->adicionaMensagem('Vínculo sem situação funcional atual', MsgCalculo::ALERTA);
            }
        }
        
        if($this->tipoMsg != "A") {
            if(!$this->alteSalario){
                MsgCalculo::getInstance()->adicionaMensagem('Vínculo sem salário cadastrado', MsgCalculo::ALERTA);
            }
        }
    }
    
    public function validaOcupacao(){
        
        if($this->tipoMsg != "A") {
            if(is_object($this->ocupacao)){
                if(!$this->ocupacao->historico->getNrcbo()){
                    MsgCalculo::getInstance()->adicionaMensagem('CBO não está cadastrado para ocupação '.$this->ocupacao->historico->getNmocupacaoh(), MsgCalculo::ERRO);
                }
            }else{
                MsgCalculo::getInstance()->adicionaMensagem('Vínculo sem ocupação', MsgCalculo::ERRO);
            }
        }
    }
    
    public function validaEscala(){
        
        if($this->tipoMsg != "A") {
            if(is_object($this->escala->historico)){
                if(!$this->escala->historico->getNrtpjornada()){
                    MsgCalculo::getInstance()->adicionaMensagem('Tipo de jornada não está cadastrado para Escala '.$this->escala->historico->getNrescalatrabm().' - '.$this->escala->historico->getNmescalatrabh(), MsgCalculo::ERRO);
                }
                if(!$this->escala->historico->getNrtpintervalo()){
                    MsgCalculo::getInstance()->adicionaMensagem('Tipo de intervalo não está cadastrado para Escala '.$this->escala->historico->getNrescalatrabm().' - '.$this->escala->historico->getNmescalatrabh(), MsgCalculo::ALERTA);
                }
            }else{
                MsgCalculo::getInstance()->adicionaMensagem('Vínculo sem escala de trabalho', MsgCalculo::ERRO);
            }
        }
    }
    
    public function retornaValidacaoSistema($params, $conditions){
        return $this->validacaoSistemaRepository->retornaValidacaoSistema($params, $conditions);
    }
}