CREATE OR REPLACE TRIGGER PTO_GERA_SITUFUNC_OCORRENCIA

AFTER INSERT OR UPDATE OR DELETE

ON PTO_PROGOCORRENCIA FOR EACH ROW

DECLARE  

  V_NRMOTIVOOCORFREQ NUMBER := NULL;

  V_NRMOTIVOAFAST    NUMBER := NULL;

  V_NRSITUFUNCM      NUMBER := NULL;

  V_NRPROXSITUFUNC   NUMBER := 1;

  V_NRQTDIASITUFUNC  NUMBER := NULL;

  V_PRXCODOCOR       VARCHAR2(20);

  

BEGIN           



  /* insere a situação funcional apenas se a ocorrência for confirmada/aprovada */

  IF :NEW.IDPROGOCORCONFIRMADA = 'S' THEN

  

    /* define depara dos motivos de ocorrência com os motivos de afastamento */

    CASE :NEW.NRMOTIVOOCORFREQ

      WHEN 5  THEN V_NRMOTIVOAFAST := 22;

      /*WHEN 6  THEN V_NRMOTIVOAFAST := 63;

      WHEN 7  THEN V_NRMOTIVOAFAST := 9;

      WHEN 8  THEN V_NRMOTIVOAFAST := 9;

      WHEN 14 THEN V_NRMOTIVOAFAST := 20;

      WHEN 15 THEN V_NRMOTIVOAFAST := 3;

      WHEN 16 THEN V_NRMOTIVOAFAST := 62;

      WHEN 17 THEN V_NRMOTIVOAFAST := 58;

      WHEN 18 THEN V_NRMOTIVOAFAST := 64;

      WHEN 19 THEN V_NRMOTIVOAFAST := 2;

      WHEN 20 THEN V_NRMOTIVOAFAST := 1;

      WHEN 22 THEN V_NRMOTIVOAFAST := 59;*/

      ELSE V_NRMOTIVOAFAST := NULL;

    END CASE;

  

    /* define depara dos motivos de ocorrência com as situações funcionais */

    CASE :NEW.NRMOTIVOOCORFREQ

      WHEN 5  THEN V_NRSITUFUNCM := 12;

      /*WHEN 14 THEN V_NRSITUFUNCM := 6;

      WHEN 15 THEN V_NRSITUFUNCM := 5;

      WHEN 16 THEN V_NRSITUFUNCM := 12;

      WHEN 20 THEN V_NRSITUFUNCM := 16;*/

      ELSE V_NRSITUFUNCM := NULL;

    END CASE;



    /* insere a situação funcional apenas se for encontrado o DePara por ser campo obrigatório */

    IF V_NRSITUFUNCM IS NOT NULL THEN



      IF INSERTING THEN

       

        /* Insere situação funcional referente a ocorrência */   

        NOVO_CODIGO_SC('GPE_ALTESITUFUNC', V_PRXCODOCOR, 1, :NEW.NRORG);

        INSERT INTO GPE_ALTESITUFUNC (NRALTESITUFUNC,NRORG,NRMOTIVOAFASTA,NRPROXSITUFUNC,CDTABECDI,CDDIAGNOST,NRSITUFUNCM,NRVINCULOM,DTINISITUFUNC,DTFIMSITUFUNC,DTVERIFSITUFUNC,DTPREVIRETOSITU,DTPRORRSITUFUNC,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,DSOBSALTSITFUNC,NRQTDIASITUFUNC,DTESTABSITUFUNC) 

             VALUES ((SELECT MAX(NRALTESITUFUNC) + 1 FROM GPE_ALTESITUFUNC WHERE NRORG = :NEW.NRORG)/*TO_NUMBER(V_PRXCODOCOR)*/, :NEW.NRORG, V_NRMOTIVOAFAST, V_NRPROXSITUFUNC, NULL, NULL, V_NRSITUFUNCM, :NEW.NRVINCULOM, :NEW.DTINICIOPROGOCOR, :NEW.DTFIMPROGOCOR, NULL, NULL, NULL, SYSDATE, SYSDATE, :NEW.NRORG, :NEW.CDOPERINCLUSAO, NULL, NULL, :NEW.DSOBSERVACAO, NULL, NULL);

      

        /* Insere situação funcional referente volta em atividade normal */   

        NOVO_CODIGO_SC('GPE_ALTESITUFUNC', V_PRXCODOCOR, 1, :NEW.NRORG);

        INSERT INTO GPE_ALTESITUFUNC (NRALTESITUFUNC,NRORG,NRMOTIVOAFASTA,NRPROXSITUFUNC,CDTABECDI,CDDIAGNOST,NRSITUFUNCM,NRVINCULOM,DTINISITUFUNC,DTFIMSITUFUNC,DTVERIFSITUFUNC,DTPREVIRETOSITU,DTPRORRSITUFUNC,DTINCLUSAO,DTULTATU,NRORGINCLUSAO,CDOPERINCLUSAO,NRORGULTATU,CDOPERULTATU,DSOBSALTSITFUNC,NRQTDIASITUFUNC,DTESTABSITUFUNC) 

             VALUES ((SELECT MAX(NRALTESITUFUNC) + 1 FROM GPE_ALTESITUFUNC WHERE NRORG = :NEW.NRORG)/*TO_NUMBER(V_PRXCODOCOR)*/, :NEW.NRORG, NULL, NULL, NULL, NULL, V_NRPROXSITUFUNC/*V_NRSITUFUNCM*/, :NEW.NRVINCULOM, :NEW.DTFIMPROGOCOR + 1, NULL, NULL, NULL, NULL, SYSDATE, SYSDATE, :NEW.NRORG, :NEW.CDOPERINCLUSAO, NULL, NULL, NULL, NULL, NULL);

      

      ELSIF UPDATING THEN

      

        /* Atualiza dados da situação funcional referente a ocorrência */

        UPDATE GPE_ALTESITUFUNC 

           SET DTINISITUFUNC = :NEW.DTINICIOPROGOCOR, DTFIMSITUFUNC = :NEW.DTFIMPROGOCOR,

               NRSITUFUNCM = V_NRSITUFUNCM, NRMOTIVOAFASTA = V_NRMOTIVOAFAST, DSOBSALTSITFUNC = :NEW.DSOBSERVACAO

         WHERE NRORG          = :OLD.NRORG

           AND NRVINCULOM     = :OLD.NRVINCULOM

           AND DTINISITUFUNC  = :OLD.DTINICIOPROGOCOR

           AND DTFIMSITUFUNC  = :OLD.DTFIMPROGOCOR;

           

        /* Atualiza dados da situação funcional referente volta em atividade normal */

        UPDATE GPE_ALTESITUFUNC 

           SET DTINISITUFUNC = :NEW.DTFIMPROGOCOR + 1

         WHERE NRORG          = :OLD.NRORG

           AND NRVINCULOM     = :OLD.NRVINCULOM

           AND DTINISITUFUNC  = :OLD.DTFIMPROGOCOR + 1

           AND NRSITUFUNCM    = V_NRPROXSITUFUNC

           AND DTFIMSITUFUNC IS NULL;

      

      END IF;                     

    END IF;

    

  ELSIF DELETING THEN

      

        /* Exclui situação funcional referente a ocorrência */

        DELETE FROM GPE_ALTESITUFUNC

         WHERE NRORG          = :OLD.NRORG

           AND NRVINCULOM     = :OLD.NRVINCULOM

           AND DTINISITUFUNC  = :OLD.DTINICIOPROGOCOR

           AND DTFIMSITUFUNC  = :OLD.DTFIMPROGOCOR;

      

        /* Exclui situação funcional referente volta em atividade normal */

        DELETE FROM GPE_ALTESITUFUNC

         WHERE NRORG          = :OLD.NRORG

           AND NRVINCULOM     = :OLD.NRVINCULOM

           AND DTINISITUFUNC  = :OLD.DTFIMPROGOCOR + 1

           AND NRSITUFUNCM    = V_NRPROXSITUFUNC

           AND DTFIMSITUFUNC IS NULL;

  END IF;

END;


