<?php
/**
 * Created by PhpStorm.
 * User: phillipesilva
 * Date: 31/07/14
 * Time: 09:37
 */

namespace Folha\Logic\ApuracaoFrequencia;

use Folha\Entities\PtoPeriodoapuracao;
use HCM\Util\DateUtil;

class PeriodoApuracao {
    public static function getFirstAndLastDtPeriodoApuracao($nrTipoPeriodo, $nrOrg)
    {
        $wherePeriodoApuracao = "NRTIPOPERIODOAPURACAO = ?
                             AND NRORG = ?";
        $orderByPeriodoApuracao = "DTFINALAPURACAO";
        $paramsPeriodoApuracao = array($nrTipoPeriodo, $nrOrg);

        $periodos = PtoPeriodoapuracao::getObjectsByWhere($wherePeriodoApuracao, $paramsPeriodoApuracao, $orderByPeriodoApuracao);

        $datas = array();

        if(count($periodos) > 0){
            $datas['FIRST'] = $periodos[0]->getDtinicialapuracao();
            $datas['LAST']  = $periodos[count($periodos)-1]->getDtfinalapuracao();
        }

        return $datas;
    }

    public static function excluiPeriodoApuracao($nrTipoPeriodo, $nrOrg)
    {
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();

        $mannager = \Setforms2\Shared\Registry::getEntityManager();
        $periodos = PtoPeriodoapuracao::findByNrtipoperiodoapuracaoAndNrorg($nrTipoPeriodo, $nrOrg);

        try {
            foreach($periodos as $periodo) {
                if(is_object($periodo)) {
                    $periodo->delete();
                }
            }
            $mannager->flush();
            $db->getConn()->commit();
        }catch(\Exception $e){
            $db->getConn()->rollback();
            throw $e;
        }
    }
} 